var async = require('async');
var validJs = require('./lib/validated');
var memcached = require('./lib/memcached');
var s3Manger = require('./lib/s3.manger');
var mailManger = require('./lib/mail.manger');
var logManger = require('./lib/log.manger');
var utilManger = require('./lib/util.manger');
var stockManger = require('./lib/stock.manger');
var mailUtil = require('./lib/mail.util');
var excelUtil = require('./lib/excel.util');
var excelManger = require('./lib/excel.manger');
var cachedUrl="";
const coreDB = require('qaq-core-db');
const coreUtil = require('qaq-core-util');
var replaceall = require("replaceall");
var issRtnManger = require('./lib/issueReturn.manger');
var accountManger = require('./lib/accounts.manger');

 function isTokenValid(params){
    return new Promise(function(resolve,reject) {
      var isVaild= validJs.isTokenValid(params);
      resolve(isVaild);
    });
 }


 exports.tokenValidation =  function(params,cachedUrl){
  return new Promise(function(resolve,reject) {
   validJs.tokenValidation(params,cachedUrl,function(error,data){
    resolve(data);
   })
  })
 }

 exports.isLogin =  function(params){
  return new Promise(function(resolve,reject) {
   validJs.isLogin(params,function(error,data){
    resolve(data);
   });
  });
 }


 exports.isLoginWithModule =  function(params){
  return new Promise(function(resolve,reject) {
   validJs.isLoginWithModule(params,function(error,data){
    resolve(data);
   });
  });
 }

 exports.getClientKey =  function(params,cachedUrl){
  return new Promise(function(resolve,reject) {
   validJs.getClientKey(params,cachedUrl,function(error,data){
    resolve(data);
   });
  });
 }

 
 exports.inputValidation =  function(params){
    return new Promise(function(resolve,reject) {
     validJs.inputValidation(params,function(error,data){
      resolve(data);
     })
    })
   }

 exports.getCache = function(key,cachedUrl){
  return new Promise(function(resolve,reject) {
     var data= memcached.getCache(key,cachedUrl);
     resolve(data);
  });
 }

 exports.setCache = function(key, cachedUrl,value){
   memcached.setCache(key, cachedUrl,value);
}


//S3 funcations

exports.readS3File = function(params){
  return new Promise(function(resolve,reject) {
    var data= s3Manger.readFile(params ,function(error,data){
    resolve(data);
    });
 });
}


//Mail function

exports.sendMail=function(mailOptions) {
    return new Promise(function(resolve,reject) {
        mailManger.sendMail(mailOptions, function(error,data){
            resolve(data);
         });
    });
}

exports.mailFormat = function(params){
  return new Promise(function(resolve,reject) {
    var data= mailManger.mailFormat(params ,function(error,data){
    resolve(data);
    });
 });
}

exports.updateAccessLog =  function(params){
  return new Promise(function(resolve,reject) {
    logManger.updateAccessLog(params,function(error,data){
    resolve(data);
   });
  });
 }

 exports.execSaveMailLog =  function(params,tpoolconn){
    return new Promise(function(resolve,reject) {
        logManger.saveMailLog(params,tpoolconn,function(error,data){
            resolve(data);
        });
    });
}

 exports.splice = function(params){
  return new Promise(function(resolve,reject) {
 validJs.splice(arrA,arrB, function(error,data){
    resolve(data);
   });
  });
  }

// util funcations

exports.formFieldDefination = function(params){
  return new Promise(function(resolve,reject) {
  utilManger.formFieldDefination(params, function(error,data){
    resolve(data);
   });
  });
  }


  exports.pageDisplay = function(params){
    return new Promise(function(resolve,reject) {
    utilManger.pageDisplay(params, function(error,data){
      resolve(data);
     });
    });
    }


exports.attrStructureDetails = function(params,cachedUrl){
    return new Promise(function(resolve,reject) {
        utilManger.attrStructureDetails(params,cachedUrl, function(error,data){
            resolve(data);
        });
    });
}

exports.execBuyerBasicInfoSearch = function(params){
    return new Promise(function(resolve,reject) {
        utilManger.buyerBasicInfoSearch(params, function(error,data){
            resolve(data);
        });
    });
}

exports.execGetUserDetails = function(params,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.getUserDetails(params,tpoolconn, function(error,data){
            resolve(data);
        });
    });
}

exports.execBuyerBasicInfoSearchWithoutTerms = function(params){
    return new Promise(function(resolve,reject) {
        utilManger.buyerBasicInfoSearchWithoutTerms(params, function(error,data){
            resolve(data);
        });
    });
}


      exports.execPageDisplayMdl= function(params){
        return new Promise(function(resolve,reject) {
          utilManger.pageDisplayMdl(params, function(error,data){
            if(error){  
              reject(error);
             }
            resolve(data);
         });
        });
      }



      exports.execNmeAddtionalDetails= function(params){
        return new Promise(function(resolve,reject) {
          utilManger.nmeAdtionalDetails(params, function(error,data){
            if(error){  
              reject(error);
             }
            resolve(data);
         });
        });
      }

      exports.execMapTypeWithProcess = function(methodParam,tpoolconn){
        return new Promise(function(resolve,reject) {
          utilManger.mapTypeWithProcess(methodParam,tpoolconn, function (error, result) {
            if(error){  
              reject(error);
             }
            resolve(result);
         });
        });
    }

    exports.execProcessList=function(methodParam,tpoolconn){
      return new Promise(function(resolve,reject) {
        utilManger.getProcessList(methodParam,tpoolconn, function (error, result) {
          if(error){  
            reject(error);
           }
          resolve(result);
       });
      });
  }

  exports.execSearchFromSearchIdn=function(methodParam, tpoolconn){
    return new Promise(function(resolve, reject) {
        utilManger.searchFromSearchIdn(methodParam, tpoolconn, function(error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

  exports.execUpdateTermsIdnSearchIdn=function(buyerTermsIdn,searchIdn,tpoolconn){
    return new Promise(function(resolve,reject) {
      utilManger.updateTermsIdnSearchIdn(buyerTermsIdn,searchIdn,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execgetLoyaltyDtl = function(paramJson,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.getLoyaltyDtl(tpoolconn,paramJson, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execget_nme = function(paramJson,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.get_nme(paramJson,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}
  
exports.execEmployeeList=function(dept,nmeIdn,coIdn,tpoolconn){
  return new Promise(function(resolve,reject) {
    utilManger.getEmployeeList(dept,nmeIdn,coIdn,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.execGroupEmployeeList=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      utilManger.getGroupEmployeeList(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }
exports.execgetMaxSrt=function(tpoolconn,lov_qry,whereKeys,whereVlus,applIdn,co_idn){
  return new Promise(function(resolve,reject) {
    utilManger.getMaxSrt(tpoolconn,lov_qry,whereKeys,whereVlus,applIdn,co_idn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.execDropTempTable=function(tableName,tpoolconn){
  return new Promise(function(resolve,reject) {
    utilManger.dropTempTable(tableName,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}


exports.execCreateTempTable=function(tableName,tpoolconn){
    return new Promise(function(resolve,reject) {
      utilManger.CreateTempTable(tableName,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

exports.execDropCreateTempTableWithStructure=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.DropCreateTempTableWithStructure(methodParam,tpoolconn, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execProcessDtl=function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
      utilManger.getProcessDtl(methodParam,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.execIssueProcessDtl=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.getIssueProcessDtl(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

exports.execsummaryTrns=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        stockManger.summaryTrns(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execsummaryTransactionWeb=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        stockManger.summaryTransactionWeb(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execPostTransactionSales=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        stockManger.postTransactionSales(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execsummaryTrnsWeb=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        stockManger.summaryTrnsWeb(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execvalidateFoogleStength=function(methodParam){
    return new Promise(function(resolve, reject) {
        utilManger.validateFoogleStength(methodParam, function(error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}


exports.execgetName=function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
    utilManger.getName(methodParam,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}
exports.execExchangeRate=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      utilManger.getExchangeRate(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

  exports.execCurrentExchangeRate=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      utilManger.getCurrentExchangeRate(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }


//stock funcation

exports.execUpdateSearchIdn = function(params,tpoolconn){
  return new Promise(function(resolve,reject) {
    stockManger.updateSearchIdn(params,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}


exports.execSearchPackets = function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
    stockManger.getSearchPackets(methodParam,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}
      
exports.execgetSearchPacketsStock= function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
    stockManger.getSearchPacketsStock(methodParam,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.execattrStructureDtlWitoutGroup = function(params,tpoolconn){
    return new Promise(function(resolve,reject) {
      stockManger.getattrStructureDtlWitoutGroup(params,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

  
exports.execattrStructureDtlGroupWise= function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
    stockManger.getattrStructureDtlGroupWise(methodParam,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.execattrStructureDtl = function(params,tpoolconn){
  return new Promise(function(resolve,reject) {
    stockManger.getattrStructureDtl(params,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.execgetSearchIdn=function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
    stockManger.getSearchIdn(methodParam,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.execimageDtl=function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
    stockManger.imageDtl(methodParam,tpoolconn, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}

exports.excuteExcelFormatList=function(params,connection){
    return new Promise(function(resolve,reject) {
        stockManger.ExcelFormatList(params,connection, function(error,data){
      resolve(data);
     });
    });
}

// mail funcation

exports.sendWebMail=function(methodParam,tpoolconn){
  return new Promise(function(resolve,reject) {
    mailUtil.sendMemoMail(tpoolconn,methodParam, function (error, result) {
      if(error){  
        reject(error);
       }
      resolve(result);
   });
  });
}


exports.sendBidMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      mailUtil.sendBidMail(tpoolconn,methodParam, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

  exports.sendTransMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      mailUtil.sendTransMail(tpoolconn,methodParam, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

  exports.sendAttrUpdateMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      mailUtil.sendAttrUpdateMail(tpoolconn,methodParam, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

  exports.execSendReviseMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      mailUtil.sendReviseMail(tpoolconn,methodParam, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

  exports.sendTransMailWithoutPromise=function(methodParam,tpoolconn,callback){
    let outJson = {};
    mailUtil.sendTransMail(tpoolconn,methodParam, function (error, result) {
        if(error){  
            outJson["status"]="FAIL";
            outJson["message"]="Error In sendTransMail method!"+error;
            callback(null,outJson);
        }
        callback(null,result);
    });
}

exports.sendRejectionMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        mailUtil.sendRejectionMail(tpoolconn,methodParam, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.sendRejectionMailWithoutPromise=function(methodParam,tpoolconn,callback){
    let outJson = {};
    mailUtil.sendRejectionMail(tpoolconn,methodParam, function (error, result) {
        if(error){  
            outJson["status"]="FAIL";
            outJson["message"]="Error In sendRejectionMail method!"+error;
            callback(null,outJson);
        }
        callback(null,result);
    });
}


exports.sendCustomerReviewMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        mailUtil.CustomerReviewMail(methodParam,tpoolconn ,function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.sendDemandMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        mailUtil.demandMail(methodParam,tpoolconn, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.sendRapnetDeleteMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        mailUtil.rapnetDeleteMail(methodParam,tpoolconn ,function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.sendMfgInwardMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        mailUtil.mfgInwardMail(methodParam,tpoolconn ,function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.sendAccessLogMail=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        mailUtil.accessLogMail(methodParam,tpoolconn ,function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}
// Excel funcations

exports.saveToExcels=function(tpoolconn,methodParam){
    return new Promise(function(resolve,reject) {
      excelUtil.saveToExcels(tpoolconn,methodParam, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }
 
  exports.sendExcelMail=function(tpoolconn,methodParam){
    return new Promise(function(resolve,reject) {
      mailUtil.mailSendExcel(tpoolconn,methodParam, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
  }

  exports.saveToExcelManger=function(tpoolconn,methodParam){
    return new Promise(function(resolve,reject) {
        excelManger.saveToExcels(tpoolconn,methodParam, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
     });
    });
  }

 // direct function
 exports.validateCriteriaStrength=function(methodParam){
    let outJson = {};
    let attrType = methodParam.attrType || '';
    let coIdn = methodParam.coIdn || '';
    let attr = methodParam.attr || '';
    let attrVal = methodParam.attrVal || '';
    let statusList = methodParam.statusList || [];
    let pktTyp = methodParam.pktTyp || '';
    let pktTypList = methodParam.pktTypList || [];
    let statusListlen = statusList.length;
    let inputPacketList = [];
    let isTransId=false;
    //console.log(statusList);
    if (statusListlen > 0) {
        if (statusList[0].indexOf(",") > -1) {
            statusList = statusList[0].split(",");
        }
    }
    if((attrType != '' && attr != '' && attrVal != '') || statusListlen > 0)  {
        let attrTypeArr = attrType.split("#");
        let attrArr = attr.split("#");
        let attrValArr = attrVal.split("#");
        let attrTypeArrlen = attrTypeArr.length;
        let attrArrlen = attrArr.length;
        let attrValArrlen = attrValArr.length;
        let where_query_str = "";
        if(coIdn != '')
            where_query_str = " stt = 1 and co_idn=" + coIdn;

        if (statusList.length > 0)
            where_query_str += " and status in ('" + statusList.join("','") + "')";
    //where_query_str+=" and status = ANY(ARRAY['"+statusList.join("','")+"'])";

        if (pktTypList.length > 0){
            where_query_str += " and stock_type in ('" + pktTypList.join("','") + "')";
        } else {
            if (pktTyp != '')
                where_query_str += " and stock_type = '" + pktTyp + "'";
        }
      
        if (attrTypeArrlen == attrArrlen && attrTypeArrlen == attrValArrlen) {   
            for (let i = 0; i < attrTypeArrlen; i++) {
                let attrType = attrTypeArr[i];
                let attr = attrArr[i];
                let attrVal = attrValArr[i];
                ///    attrVal =attrVal.replace(/\s/g,'');
                attrVal = attrVal.trim();
                    
                if (attr != 'byr_rte' && attr != 'byr_dis' &&  attr !='web_memo' &&  attr !='sales_memo' && attr != 'ktsview') {
                    if (attrType == 'c') {
                        let attrvals = attrVal.split("@");
                        where_query_str += " and CAST(COALESCE(NULLIF(attr ->> '" + attr + "', ''), '0') AS INT) =ANY(ARRAY[" + attrvals.join(",") + "])";
                    } else if (attrType == 'n') {
                        if (attrVal.indexOf("~") > -1){
                            let mulAttr = attrVal.split("~");
                            //console.log(mulAttr)
                            //console.log(mulAttr.length)
                            let mul_query_str = "";
                            for(let k=0;k<mulAttr.length;k++){
                                let mulAttrVal = mulAttr[k];
                                let attrvals = mulAttrVal.split("@");
                                let attrvalslen = attrvals.length
                                if(attrvalslen == 1)
                                    attrvals.push(attrvals[0]);

                                if(mul_query_str != "")
                                    mul_query_str += " OR ";

                                mul_query_str += " str_to_num(attr ->> '" + attr + "', 0) between " + attrvals[0] + " and " + attrvals[1];
                            } 
                            where_query_str += " and  ( "+ mul_query_str +" ) ";
                        }else{
                            let attrvals = attrVal.split("@");
                            let attrvalslen = attrvals.length
                            if (attrvalslen == 1)
                                attrvals.push(attrvals[0]);
                            where_query_str += " and  str_to_num(attr ->> '" + attr + "', 0) between " + attrvals[0] + " and " + attrvals[1];
                        }
                    } else if (attrType == 'd') {
                        let attrvals = attrVal.split("@");
                        let attrvalslen = attrvals.length
                        if (attrvalslen == 1)
                            attrvals.push(attrvals[0]);
                        where_query_str += " and CAST(COALESCE(NULLIF(attr ->> '" + attr + "', ''), '0') AS INT) between " + attrvals[0] + " and " + attrvals[1];
                    } else if (attrType == 't') {
                        let attrvals = attrVal.split("@");
                        //console.log(attrvals);
                        let operator = "=";
                        let attrIndexFirst = attrvals[0];
                        if (attrIndexFirst.indexOf("%") > -1)
                            operator = "like";
                        if(attr=='vnm'){
                            where_query_str += " and (attr ->> '" + attr + "' " + operator + " ANY(ARRAY['" + attrvals.join("','") + "']) or attr ->> 'certno' " + operator + " ANY(ARRAY['" + attrvals.join("','") + "']) or  tag_id " + operator + " ANY(ARRAY['" + attrvals.join("','") + "']))";
                            inputPacketList = attrvals;
                        }else{
                            where_query_str += " and trim(attr ->> '" + attr + "') " + operator + " ANY(ARRAY['" + attrvals.join("','") + "'])";
                        }
                    }
                } else {
                    if(attr == 'ktsview'){
                        if (attrType == 'excl~t') {
                            where_query_str += " and NOT(string_to_array(attr ->> '"+attr+"', ', ') &&  string_to_array('"+attrVal+"','@')) ";
                        } else {
                            where_query_str += " and (string_to_array(attr ->> '"+attr+"', ', ') &&  string_to_array('"+attrVal+"','@')) ";
                        }
                    }else if(attr=='web_memo'){
                        
                        let attrvals = attrVal.split("@");
                        if(isTransId){
                            where_query_str += " or stock_idn in (select stock_idn from transaction_d_web a where a.transaction_web_idn=ANY(ARRAY[" + attrvals.join(",") + "])) ";
                        }else{
                            where_query_str += " and stock_idn in (select stock_idn from transaction_d_web a where a.transaction_web_idn=ANY(ARRAY[" + attrvals.join(",") + "])) ";

                        }
                         isTransId=true;
                    }else if(attr=='sales_memo'){                       
                        let attrvals = attrVal.split("@");                       
                        if(isTransId){
                            where_query_str += " or stock_idn in (select stock_idn from transaction_d_sales a where a.transaction_sales_idn=ANY(ARRAY[" + attrvals.join(",") + "])) ";
                        }else{
                            where_query_str += " and stock_idn in (select stock_idn from transaction_d_sales a where a.transaction_sales_idn=ANY(ARRAY[" + attrvals.join(",") + "])) ";

                        }    isTransId=true;
                    }else{
                        let attrvals = attrVal.split("@");
                        outJson[attr] = attrvals;
                    }
                }
            }    
        } else {
            outJson["status"] = "FAIL";
            outJson["message"] = "Attribute/Type/Sort Size Not Matching!";
            return outJson;
        }
       
        //console.log("query",where_query_str);
        outJson["where_query_str"] = where_query_str;
        outJson["attrValArr"] = attrValArr;
        outJson["attrArr"] = attrArr;
        outJson["attrTypeArr"] = attrTypeArr;
        outJson["inputPacketList"] = inputPacketList;
        //console.log("attrValArr",attrValArr);
        //console.log("attrArr",attrArr);
        //console.log("attrTypeArr",attrTypeArr);
        //console.log("inputPacketList",inputPacketList);
        outJson["status"] = "SUCCESS";
        outJson["message"] = "SUCCESS";
        return outJson;
    } else if (attrType == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify attrType Can not be blank!";
        return outJson;
    } else if (attr == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify attr Can not be blank!";
        return outJson;
    } else if (attrVal == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify attrVal Can not be blank!!";
        return outJson;
    } else if (statusListlen == 0) {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify statusList Can not be blank!!";
        return outJson;
    }
}


exports.getSearchIdn= function(methodParam,tpoolconn,callback){
  // console.log('test');
  var attrType = methodParam.attrType;
  var attr = methodParam.attr;
  var attrVal = methodParam.attrVal;
  var buyerIdn = methodParam.buyerIdn;
  var empIdn = methodParam.empIdn;
  var buyerTermsIdn = methodParam.buyerTermsIdn;
  var searchIdn = methodParam.searchIdn;
  var statusList = methodParam.statusList;
  var source = methodParam.source;
  var logUsr = methodParam.logUsr;
  let fmt = {};
  let params=[];
  let sqlQ="";
  let outJson = {};
  if(searchIdn==0 || searchIdn==''){
      sqlQ="insert into stock_search(buyer_terms_idn,request_src,request_ts,request_attr,request_attrval,request_attrtyp,request_status,created_by) \n"+
          "values($1,$2,current_timestamp,$3,$4,$5,'{"+statusList.join()+"}',$6)";
  }else{
      sqlQ="update stock_search set buyer_terms_idn=$1,request_src=$2,modified_ts=current_timestamp,request_attr=$3,request_attrval=$4,request_attrtyp=$5,request_status='{"+statusList.join()+"}',modified_by=$6 where search_id=$7"
  }
  params.push(buyerTermsIdn);
  params.push(source);
  params.push(attr);
  params.push(attrVal);
  params.push(attrType);
  params.push(logUsr);
  if(searchIdn!=0 || searchIdn!='')
  params.push(searchIdn);
  sqlQ+=" RETURNING search_id";
  // console.log(sqlQ);
  // console.log(params);
  coreDB.executeTransSql(tpoolconn,sqlQ,params,fmt,function(error,result){
      if(error){
          outJson["status"]="FAIL";
          outJson["message"]="Fail To Execute Query! "+error.message;;
          return callback(null,outJson); 
      }else{
          //coreDB.doTransCommit(tpoolconn);
          var rowCount = result.rowCount;
          if(rowCount>0){
              var resultRow=result.rows[0] || {};
              let search_id=resultRow["search_id"] || '';
              outJson["status"]="SUCCESS";
              if(searchIdn==0 || searchIdn=='')
              outJson["message"]="Search Idn Created Sucessfully";
              else
              outJson["message"]="Search Idn Updated Sucessfully";
              outJson["searchIdn"]=search_id;
          }else{
              outJson["status"]="FAIL";
              if(searchIdn==0 || searchIdn=='')
              outJson["message"]="Fail To Create Search Id!";
              else
              outJson["message"]="Fail To Update Search Id!";
          }
          return callback(null,outJson); 
      }
      });

}

exports.execStatusList= function(searchGroup,coIdn,tpoolconn,statusGrp,stock_group,prefix){
    return new Promise(function(resolve,reject) {
      stockManger.getStatusList(searchGroup,coIdn,tpoolconn,statusGrp,stock_group,prefix,function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execBiGrpStatusList= function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      stockManger.getBiGrpStatusList(methodParam,tpoolconn,function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.getDependAttrList=function(formula){
    return stockManger.getDependAttrList(formula);
}


exports.initCap =function(str) {
    return str.toLowerCase().replace(/(?:^|\s)[a-z]/g, function (m) {
       return m.toUpperCase();
    });
 };


exports.floorFigure= function(attrval,format){
    return stockManger.floorFigure(attrval,format);
};

exports.numberWithCommas = function(x) {
    var parts = x.toString().split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    return parts.join(".");
   }

exports.getDateyyyymmddToExpected= function(dte,format){
    return stockManger.getDateyyyymmddToExpected(dte,format);
}


exports.getSelectQ= function(resultView){
    return stockManger.getSelectQ(resultView);
}


exports.getSelectQMix= function(resultView){
    return stockManger.getSelectQMix(resultView);
}

exports.nvl=function(pVal,rVal){
  if (isNaN(pVal))
      return pVal||rVal;
  else if(pVal==null)   
  return rVal;
  else
  return pVal;
}

exports.modDataOfPrp=function(prpSort,prpAltGrp){
    return stockManger.modDataOfPrp(prpSort,prpAltGrp);
}

exports.getFormFieldsAll=function(param,tpoolconn,callback){
  var outJson = {};
  getFormFieldsexports(param,tpoolconn,function(error,getFormFieldsresult){
      if(error){
          outJson["status"]="FAIL";
          outJson["message"]="Error In GetFormFields Method!";
          callback(null,outJson);
      }else{
          var status = getFormFieldsresult.status || '';
          var message = getFormFieldsresult.message || '';
          if(status=="SUCCESS" && message=="SUCCESS"){
                  var appPage =getFormFieldsresult.appPage || '';
                  outJson["pageInfo"]=appPage["pageinfo"] || {};
                  outJson["actions"]=appPage["action"] || [];
                  outJson["buttons"]=appPage["button"] || [];
                  outJson["links"]=appPage["links"] || [];
                  outJson["navigation"]=appPage["navigation_links"] || [];
                  outJson["info"]=appPage["info"] || [];
                  outJson["summary"]=appPage["summary"] || [];
                  outJson["status"]="SUCCESS";
                  outJson["message"]="SUCCESS";
                  callback(null,outJson);
          }else{
          callback(null,getFormFieldsresult); 
          } 
      }
  });
}

function getFormFieldsexports(param,tpoolconn,callback) {
  getFormFields(param,tpoolconn,function(error,getFormFieldsresult){
      if(error){
          outJson["status"]="FAIL";
          outJson["message"]="Error In GetFormFields Method!";
          callback(null,outJson);
      }else{
          callback(null,getFormFieldsresult);
      }
  }); 
}

  

function getFormFields(param,tpoolconn,callback) { 
  var outJson = {};
  var formNme = param.formNme || '';
  var pvtConfigure = param.pvtConfigure || '';
  
  var co_idn = param.co_idn || '';
  var applIdn = param.applIdn || '';
  var page_tab_idn = param.page_tab_idn || '';
  var inLineEditColumn = param.inLineEditColumn || '';
  var whereKeys = param.whereKeys || '';
  var whereVlus = param.whereVlus || '';
  var pvt=null;
  if(pvtConfigure!='SYS')
  pvt='0';

  if(page_tab_idn=='')
   page_tab_idn=null;

  var conq="";

  var params = [formNme,pvt,page_tab_idn,pvt];
  if(inLineEditColumn!=''){
      conq=" and b.table_field=$5";
      params.push(inLineEditColumn);
  }

  var query = "with module_page_v as(\n" + 
  "select *\n" + 
  "from module_page where form_nme=$1 and stt=1 and pvt=COALESCE($2,pvt)\n" + 
  ")\n" + 
  "select a.page_idn, a.module_idn, a.parent_page_idn, a.page_typ, a.page_layout, \n" + 
  "a.page_nme, a.page_icon, a.title, a.dscr, a.form_nme, a.form_action, a.table_name mtable_name, \n" + 
  "a.primary_key_field, a.where_clause, a.default_data_query, a.order_by, \n" + 
  "a.display_module, a.excel_module, a.filter_keys, a.short_help, a.help, \n" + 
  "a.no_of_tabs, a.grid_columns, a.add_records, a.menu_idn,a.second_key_field,\n" + 
  "b.srt, b.is_hidden, b.itm_typ, b.itm_location, b.is_database_columnn, \n" + 
  "b.form_field, b.form_field_icon, b.form_field_title, b.table_name ptable_name, b.table_field, \n" + 
  "b.field_alias, b.dta_typ, b.form_field_typ, b.form_field_size, b.css_column_size, \n" + 
  "b.form_field_min_length, b.form_field_max_length, b.is_compulsory, b.js_scripts,\n" + 
  "b.validations, b.lov_qry, b.short_help, b.help, b.default_value, b.column_key, \n" + 
  "b.column_value, b.field_css,b.input_pattern\n" + 
  "from\n" + 
  "module_page_v a,page_item b where a.page_idn=b.page_idn and b.stt=1 and b.page_tab_idn=COALESCE($3,b.page_tab_idn) and b.pvt=COALESCE($4,b.pvt)\n" +conq+ 
  " and  COALESCE(b.co_idn,"+co_idn+")="+co_idn+" order by b.itm_typ,b.srt";
  //    console.log(query);
  // console.log(params);
  coreDB.executeTransSql(tpoolconn,query,params,{}, async function(error,result){
      if(error){
          outJson["status"]="FAIL";
          outJson["message"]="Fail To Execute getFormFields Query! "+error.message;
          callback(null,outJson);
      }else{
          var len=result.rows.length;
          if(len!=0){
              var appPage = {};
              var pageInfo = {};
              
              var page_idn="";
              var prvitm_typ="";
              var list = [];
              var data = {};
              for(var i=0;i<len;i++){
                  if(page_idn==''){
                  page_idn=result.rows[i].page_idn || "0";
                  pageInfo["page_idn"]=page_idn;
                  pageInfo["module_idn"]=result.rows[i].module_idn || "0";
                  pageInfo["parent_page_idn"]=result.rows[i].parent_page_idn || "0";
                  pageInfo["page_typ"]=result.rows[i].page_typ || "";
                  pageInfo["page_layout"]=result.rows[i].page_layout || "";
                  pageInfo["page_nme"]=result.rows[i].page_nme || "";
                  pageInfo["page_icon"]=result.rows[i].page_icon || "";
                  pageInfo["title"]=result.rows[i].title || "";
                  pageInfo["dscr"]=result.rows[i].dscr || "";
                  pageInfo["form_nme"]=result.rows[i].form_nme || "";
                  pageInfo["form_action"]=result.rows[i].form_action || "";
                  pageInfo["table_name"]=result.rows[i].mtable_name || "";
                  pageInfo["primary_key_field"]=result.rows[i].primary_key_field || "";
                  pageInfo["where_clause"]=result.rows[i].where_clause || "";
                  pageInfo["default_data_query"]=result.rows[i].default_data_query || "";
                  pageInfo["order_by"]=result.rows[i].order_by || "";
                  pageInfo["display_module"]=result.rows[i].display_module || "";
                  pageInfo["excel_module"]=result.rows[i].excel_module || "";
                  pageInfo["filter_keys"]=result.rows[i].filter_keys || "";
                  pageInfo["short_help"]=result.rows[i].short_help || "";
                  pageInfo["help"]=result.rows[i].help || "";
                  pageInfo["no_of_tabs"]=result.rows[i].no_of_tabs || "";
                  pageInfo["grid_columns"]=result.rows[i].grid_columns || "";
                  pageInfo["add_records"]=result.rows[i].add_records || "";
                  pageInfo["menu_idn"]=result.rows[i].menu_idn || "";
                  pageInfo["second_key_field"]=result.rows[i].second_key_field || "";
                  pageInfo["input_pattern"]=result.rows[i].input_pattern || "";
                  appPage["pageinfo"]=pageInfo;
                  }
                  var itm_typ=result.rows[i].itm_typ || "";
                  if(prvitm_typ=="")
                  prvitm_typ=itm_typ;
                  if(itm_typ!=prvitm_typ){
                      appPage[prvitm_typ]=list;
                      list = [];
                      prvitm_typ=itm_typ;
                  }
                  data = {};
                  var default_value=result.rows[i].default_value || ""
                  var form_field_typ=result.rows[i].form_field_typ || "";
                  var lov_qry=result.rows[i].lov_qry || ""
                  var form_field=result.rows[i].form_field || ""
                  var table_field=result.rows[i].table_field || ""
                  data["srt"]=result.rows[i].srt || "";
                  data["is_hidden"]=result.rows[i].is_hidden || "0";
                  data["itm_location"]=result.rows[i].itm_location || "";
                  data["is_database_columnn"]=result.rows[i].is_database_columnn || "";
                  data["form_field"]=form_field;
                  data["form_field_icon"]=result.rows[i].form_field_icon || "";
                  data["form_field_title"]=result.rows[i].form_field_title || "";
                  data["table_name"]=result.rows[i].ptable_name || "";
                  data["table_field"]=table_field;
                  data["field_alias"]=result.rows[i].field_alias || "";
                  data["dta_typ"]=result.rows[i].dta_typ || "";

                  if(form_field_typ=="l")
                  data["kv"]=getLOVList(lov_qry);
                  else if((form_field_typ=="j"))
                  data["kv"]=getLOVList(lov_qry);    
                  else
                  data["kv"]="";
                  

                  data["form_field_typ"]=form_field_typ;
                  data["form_field_size"]=result.rows[i].form_field_size || "";
                  data["css_column_size"]=result.rows[i].css_column_size || "";
                  data["form_field_min_length"]=result.rows[i].form_field_min_length || "";
                  data["form_field_max_length"]=result.rows[i].form_field_max_length || "";
                  data["is_compulsory"]=result.rows[i].is_compulsory || "";
                  data["js_scripts"]=result.rows[i].js_scripts || "";
                  data["validations"]=result.rows[i].validations || "";
                  data["lov_qry"]=lov_qry;
                  data["short_help"]=result.rows[i].short_help || "";
                  data["help"]=result.rows[i].help || "";
                  if(default_value=='#COIDN')
                  default_value=co_idn;
                  // console.log("MB-"+default_value+"-"+result.rows[i].form_field || "")
                  data["default_value"]=default_value;
                  data["column_key"]=result.rows[i].column_key || "";
                  data["column_value"]=result.rows[i].column_value || "";
                  data["field_css"]=result.rows[i].field_css || "";   
                  if((table_field=="srt" || form_field=="srt") && lov_qry!=''){
                      data["default_value"]=await execgetMaxSrt(tpoolconn,lov_qry,whereKeys,whereVlus,applIdn,co_idn)
                  }             
                  list.push(data);
              }
              if(prvitm_typ!=''){
                  appPage[prvitm_typ]=list;
              }
              
              outJson["appPage"]=appPage;
              outJson["status"]="SUCCESS";
              outJson["message"]="SUCCESS";
          }else{
              outJson["status"]="SUCCESS";
              if(inLineEditColumn!=''){
              outJson["message"]="Field Not Editable";
              }else{
              outJson["message"]="Sorry No result Found of Form";
              }
          }
          callback(null,outJson);
      }
  });
}

exports.getLOVList=function(lov_qry){
  var kv=[];
  var map = {};
  map["k"]="null";
  map["v"]="Select";
  kv.push(map);
  if(lov_qry!=""){
      var arr = lov_qry.split(",");
      var len=arr.length;
      if((len%2) ==0){
          for(var i=0;i<len;i++){
              map = {};
              map["k"]=arr[i++];
              map["v"]=arr[i];
              kv.push(map);
          }
      }
  }
  return kv;
}


exports.getPageDefination=function(connection,paramJson,callback){
  var pvtConfigure = paramJson.pvtConfigure || '';
  var coIdn = paramJson.coIdn || '';
  var formNme = paramJson.formNme || '';
  var userIdn = paramJson.userIdn || '';
  var outJson = {};
  var criteriaDtlLst = {};

  if(pvtConfigure != ''&& formNme != ''){
      var param = {
          "db":connection,
          "formName":formNme,
          "coIdn":coIdn,
          "userCtg":pvtConfigure,
          "userIdn":userIdn
      }
      coreUtil.formFieldDefination(param).then(fieldDefination=>{           
          fieldDefination = fieldDefination || {};
          var fieldDefinations=Object.keys(fieldDefination) || [];
          var fieldDefinationslen=fieldDefinations.length;
          if(fieldDefinationslen > 0){
              if(fieldDefination["status"]== 'SUCCESS'){
                  outJson["result"]=fieldDefination["result"];;
                  outJson["status"]="SUCCESS";
                  outJson["message"]="SUCCESS"; 
                  callback(null,outJson);
              }else{
                  callback(null,fieldDefination);
              }
          }else{
              outJson["result"]='';
              outJson["status"]="FAIL";
              outJson["message"]="Please Verify formFieldDefination Can not be blank!";
              callback(null,outJson);
          }
      })               
  }else if(pvtConfigure == ''){
      outJson["result"]='';
      outJson["status"]="FAIL";
      outJson["message"]="Please Verify pvtConfigure Parameter";
      callback(null,outJson);
  }else if(formNme == ''){
      outJson["result"]='';
      outJson["status"]="FAIL";
      outJson["message"]="Please Verify Form Name Parameter";
      callback(null,outJson);
  }
}

exports.getSelectIssueQ=function(resultView,pktTyp){
  let queryStr="stock_idn,pkt_code,stock_type,status,qty_on_hand,weight_on_hand,attr ->> 'rap_rte' benchmark_rte,attr ->> 'rte' asking_rte,sort";
  let resultViewlen=resultView.length;
  let format = 2;
  if(pktTyp == 'MIX')
    format = 3;
  for (let i = 0; i < resultViewlen; i++){
      let attr= resultView[i];
      if (attr == 'crtwt')
        queryStr += ", trunc(CAST(attr ->> 'crtwt' as Numeric),"+format+")  " + attr;
      else
      queryStr+=", attr ->> '"+attr+"' "+attr;
  }
  return queryStr;
}

exports.executeGetNextValFromSeq = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        getNextValFromSeqDtl(tpoolconn, methodParam, function (error, data) {
            resolve(data);
        });
    });
}

exports.getNextValFromSeq = function(connection,paramJson,callback) { 
    var seqNm = paramJson.seqNm || '';
    paramJson={};  
    var outJson={};

    paramJson["seqNm"]=seqNm;
    getNextValFromSeqDtl(connection,paramJson,function(error,seqDetails){
        if(error){
            console.log(error);
            outJson["result"]='';
            outJson["status"]="FAIL";
            outJson["message"]="Fail To Get Next Val From Seq!";
            callback(null,outJson);
        }else{
            callback(null,seqDetails);    
        }
    });                    
};

function getNextValFromSeqDtl(connection,paramJson,callback){
  var seqNm = paramJson.seqNm || '';
  var outJson = {};
  if(seqNm != ''){  
      var params = [seqNm];
      var fmt = {};
      var query = "SELECT nextval($1) seq";
      //console.log(query);
      //console.log(seqNm);
      coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
          if(error){
              console.log(error);
              outJson["result"]='';
              outJson["status"]="FAIL";
              outJson["message"]="Get Seq Fail To Execute Query!";
              callback(null,outJson);
          }else{
              if(result.rowCount > 0){
                  var seq = result.rows[0].seq;
                  // console.log("seq"+seq);
                  outJson["result"]=seq;
                  outJson["status"]="SUCCESS";
                  outJson["message"]="SUCCESS";
                  callback(null,outJson);
              }else{
                  outJson["result"]="";
                  outJson["status"]="FAIL";
                  outJson["message"]="Fail to get Sequence";
                  callback(null,outJson);
              }
          }
      });               
  }else if(seqNm == ''){
      outJson["result"]='';
      outJson["status"]="FAIL";
      outJson["message"]="Please Verify Sequence Name Parameter";
      callback(null,outJson);
  }
}

exports.executeGetTranEmployee = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        utilManger.getTranEmployee(tpoolconn, methodParam, function (error, data) {
            resolve(data);
        });
    });
}

exports.getApplicationList = function(param,tpoolconn,callback){
  var pvtConfigure = param.pvtConfigure || '';
  var co_idn = param.co_idn || '';
  let applIdn = param.applIdn || '';
  let applicationStr = param.applicationStr || '';

  var pvt="pvt = 0";
  if(pvtConfigure=='SYS')
  pvt="pvt >= 0";

  var outJson = {};
  var kv=[];
  var map = {};
  map["k"]="";
  map["v"]="Select";
  kv.push(map);
  var params = [];

  var query="select appl_idn k,nme v from appl_info where stt=1 and owned_by = $1 or owned_by =108 ";
  params.push(co_idn);
  let cnt = 1;
  if(applIdn != ''){
        cnt++
        query +=" and ref_appl_idn= $"+cnt;
        params.push(applIdn);
  }
  if(applicationStr != ''){
        query += " and nme like '"+applicationStr+"%' ";
  }
  //console.log(query);
  //console.log(params);
  coreDB.executeTransSql(tpoolconn,query,params,{}, function(error,result){
      if(error){
          outJson["kv"]=kv;
          outJson["status"]="FAIL";
          outJson["message"]=error.message;
          callback(null,outJson);
      }else{
          var len=result.rows.length;

          if(len!=0){
              for(var i=0;i<len;i++){
                  map = {};
                  map["k"]=result.rows[i].k || "";
                  map["v"]=result.rows[i].v || "";
                  kv.push(map);
              }
              outJson["kv"]=kv;
              outJson["status"]="SUCCESS";
              outJson["message"]="SUCCESS";
              callback(null,outJson);
          }else{
              outJson["kv"]=kv;
              outJson["status"]="SUCCESS";
              outJson["message"]="SUCCESS";
              callback(null,outJson);
          }
      }
  });
}

exports.execGetUpdateUserMenus= function(connection,params){
    return new Promise(function(resolve,reject) {
        coreUtil.getUpdateUserMenus(connection,params, function(error,data){
        if(error){  
          reject(error);
         }
        resolve(data);
     });
    });
  }

exports.getUpdateUserMenus = function(connection,paramJson,callback){
  var userId = paramJson["userId"];
  var stt = paramJson["stt"];
  var logUsr = paramJson["logUsr"];
  var menuIdn = paramJson["menuIdn"];
  var outJson = {};

  var params = [stt,logUsr,menuIdn,userId];
  var fmt = {};
  var query = "update user_menu set stt = $1,modified_ts=now(),modified_by=$2 where menu_idn = $3 and user_idn=$4";
    //console.log(query);
    //console.log(params);
  coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
      if(error){
          console.log(error);
          outJson["result"]='';
          outJson["status"]="FAIL";
          outJson["message"]="Update User Menu Fail To Execute Query!";
          callback(null,outJson);
      }else{
          //coreDB.doTransCommit(connection);
          var rowCount = result.rowCount;
          //console.log("rowCount",rowCount);
      
          if(rowCount>0){
              outJson["result"]="";
              outJson["status"]="SUCCESS";
              outJson["message"]="User Menu Updated Successfully";
              callback(null,outJson);
          }else{
              params["seqNm"] = "user_menu_seq";
              coreUtil.getNextValFromSeq(connection,params,function(error,seqresult){
                  var status = seqresult["status"];
                  //console.log("seqresult",seqresult)
                  if(status == "SUCCESS"){
                      var logId = seqresult["result"] || '';
                      //console.log("seqresult",seqresult)

                      var paramms = [logId,userId,menuIdn,stt,logUsr];
                      fmt = {};
                      var insLogQ = " insert into user_menu(user_menu_idn,user_idn,menu_idn,stt,start_dt,created_ts,created_by) values($1,$2,$3,$4,CURRENT_DATE,now(),$5)";
                      //console.log(insLogQ);
                      //console.log(paramms);
                      coreDB.executeTransSql(connection,insLogQ,paramms,fmt,function(error,result){
                          if(error){
                              console.log(error);                     
                              outJson["result"]='';
                              outJson["status"]="FAIL";
                              outJson["message"]="Insert User Menu Fail To Execute Query!";
                              callback(null,outJson);
                          }else{
                              //coreDB.doTransCommit(connection);
                              var rowCount = result.rowCount;  
                                outJson["result"]="";
                                outJson["status"]="SUCCESS";
                                outJson["message"]="User Menu Updated Successfully";
                                callback(null,outJson);                                  
                          }
                      });
                  }
              })
          }
      }
  })         
}

exports.execMultiEmailIds= function(params){
    return new Promise(function(resolve,reject) {
      utilManger.multiEmailIds(params, function(error,data){
        if(error){  
          reject(error);
         }
        resolve(data);
     });
    });
  }

  exports.execCheckSendMailBuyer= function(params){
    return new Promise(function(resolve,reject) {
        utilManger.checkSendMailBuyer(params, function(error,data){
            if(error){  
                reject(error);
            }
            resolve(data);
        });
    });
  }

  exports.execNextTrnsProcessQc = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.nextTrnsProcessQc(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}
 
 

exports.execnextdistinctTrnsProcessQc = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.nextdistinctTrnsProcessQc(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}


exports.execTransactionBuyerList = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        utilManger.getTransactionTermsList(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetAddressDetails = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        utilManger.getAddressDetails(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetGroupCompanyDetails = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        utilManger.getGroupCompanyDetails(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetProcessDetails = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        utilManger.getProcessDetails(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execPacketCreation=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        stockManger.packetCreation(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execGetPacketDtlOld= function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      stockManger.getPacketDtlOld(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execGetPacketDtl= function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      stockManger.getPacketDtl(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execGetRfidDevice = function(tpoolconn,paramJson){
    return new Promise(function(resolve,reject) {
        stockManger.getRfidDevice(tpoolconn,paramJson, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetAuctionDetails = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        utilManger.getAuctionDetails(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetKtsAttr= function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
      stockManger.getKtsAttr(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.authTokenValidation =  function(params){
    return new Promise(function(resolve,reject) {
        validJs.authTokenValidation(params,function(error,data){
            resolve(data);
        });
    });
}

exports.execDeleteNonBidPkt = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        stockManger.deleteNonBidPacket(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execDeleteUpcomingPkt = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        stockManger.deleteUpcomingPacket(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetAttrList = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.getAttrList(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}


exports.execGetProcessDtls = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getProcessDtls(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        })
    })
}

exports.execInsertIssueDataToTemp = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.insertIssueDataToTemp(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execCheckTransactionQCM = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.checkTransactionQCM(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execValidateTempPackets = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.validateTempPackets(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        })
    })
}

exports.execUpdateStockMIssueStatus = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.updateStockMIssueStatus(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execInsertTransactionQcD = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.insertTransactionQcD(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execPostAssortIssueProcedure = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.postAssortIssueProcedure(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execPreAssortReturnProcedure = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.preAssortReturnProcedure(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execUpdateStockMIssueAttr = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.updateStockMIssueAttr(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execInsertStockMGrps = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.insertStockMGrps(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execUpdateStockMAttr = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.updateStockMAttr(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execUpdateStockMStatusDRT = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.updateStockMStatusDRT(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetFailPktList = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getFailPktList(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execSendBulkUpdateMail = function(methodParam) {
    return new Promise(function (resolve, reject) {
        issRtnManger.sendBulkUpdateMail(methodParam, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execGetTransactionSummary = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getTransactionSummary(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execUpdateError = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.updateError(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetProcessSettingAttr = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getProcessSettingAttr(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execGetProcessAttr = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getProcessAttr(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execGetStockAttr = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getStockAttr(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execGetEmpDetails = function(methodParam,tpoolconn) {
    return new Promise(function (resolve, reject) {
        utilManger.getEmpDetails(methodParam,tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execPostAssortReturnProc=function(methodParam,tpoolconn,callback){
    let outJson = {};
    issRtnManger.postAssortReturnProc(methodParam,tpoolconn, function (error, result) {
        if(error){  
            outJson["status"]="FAIL";
            outJson["message"]="Error In postAssortReturnProc method!"+error;
            callback(null,outJson);
        }
        callback(null,result);
    });
}

exports.execPostAssortReturnProcWithPromise = function(methodParam,tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.postAssortReturnProc(methodParam,tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execDoApplyBenchmark=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        stockManger.doApplyBenchmark(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execGetAndUpdateBenchmark=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        stockManger.getAndUpdateBenchmark(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

exports.execCreateMixMktPacket= function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        stockManger.createMixMktPacket(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execCreateMixAsrtPacket = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        stockManger.createMixAsrtPacket(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execUpdatePacketSort = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        stockManger.updatePacketSort(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execGetBenchMarkRte = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        stockManger.getBenchMarkRte(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execGetLoyaltyDetails = function(paramJson,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.getLoyaltyDetails(tpoolconn,paramJson, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetAuthUser = function(methodParam,connectionWR,connectionRD){
    return new Promise(function(resolve,reject) {
        utilManger.authUser(connectionWR,connectionRD,methodParam, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetLoginId = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.getLoginId(tpoolconn,methodParam, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execCheckTransactionMixQCM = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.checkTransactionMixQCM(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

exports.execInsertTransactionMixQcD = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.insertTransactionMixQcD(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execUpdateErrorMix = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.updateErrorMix(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execPostAssortIssueProcedureMix = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.postAssortIssueProcedureMix(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execPreAssortReturnProcedureMix = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.preAssortReturnProcedureMix(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetTransactionMixSummary = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getTransactionMixSummary(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execPostAssortReturnProcMix=function(methodParam,tpoolconn,callback){
    let outJson = {};
    issRtnManger.postAssortReturnProcMix(methodParam,tpoolconn, function (error, result) {
        if(error){  
            outJson["status"]="FAIL";
            outJson["message"]="Error In postAssortReturnProc method!"+error;
            callback(null,outJson);
        }
        callback(null,result);
    });
}

exports.execGetSaveRepairDataToMFG = function(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        issRtnManger.getSaveRepairDataToMFG(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetSaveLedgerDtl=function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.getSaveLedgerDtl(methodParam,tpoolconn, function (error, result) {
            if(error){  
                reject(error);
            }
                resolve(result);
        });
    });
}

exports.execGetAccLedgerDtl = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.getAccLedgerDtl(tpoolconn,methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetAccSettLedgerDtl = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.getAccSettLedgerDtl(tpoolconn,methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetNotes = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.getNotes(tpoolconn,methodParam, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execSetLedgerBal = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.setLedgerBal(tpoolconn,methodParam, function (error, result) {
            if(error){  
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetSaleData = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.getSaleData(tpoolconn,methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

exports.execSendStorageImageMail = function(methodParam,connection) {
    return new Promise(function (resolve, reject) {
        mailUtil.sendStorageImageMail(methodParam,connection, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    })
}

function execUnlock(methodParam) {
  return new Promise(function (resolve, reject) {
    utilManger.unlock(methodParam, function (error, result) {
          if (error) {
              reject(error);
          }
          resolve(result);
      });
  });
}

exports.execGetPbbXrte = function(methodParam,connection) {
    return new Promise(function (resolve, reject) {
      utilManger.getPbbXrte(methodParam,connection, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetMenuRightsDtl = function(methodParam,connection) {
    return new Promise(function (resolve, reject) {
      utilManger.getMenuRightsDtl(methodParam,connection, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetStateByCity = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.getStateByCity(methodParam,tpoolconn, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}


exports.execGetSignatoryNmeDtl = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        accountManger.getSignatoryNmeDtl(tpoolconn,methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}
exports.execGetComparisionExcel= function(methodParam){
    return new Promise(function(resolve,reject) {
       excelManger.getComparisionExcel(methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}



exports.execGetShipingBillExcel= function(methodParam){

    return new Promise(function(resolve,reject) {

        excelManger.getShipingBillExcel(methodParam, function (error, result) {

            if(error){  

            reject(error);

            }

            resolve(result);

        });

    });

}


exports.execCertificationStatmentExcel= function(methodParam){

    return new Promise(function(resolve,reject) {

         excelManger.getCertificationStatmentExcel(methodParam, function (error, result) {

            if(error){  

            reject(error);

            }

            resolve(result);

        });

    });

}

exports.execgetBVCAgentExcel= function(methodParam){
    return new Promise(function(resolve,reject) {
       excelManger.getBVCAgentExcel(methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}


exports.execgetJKAgentExcel= function(methodParam){
    return new Promise(function(resolve,reject) {
       excelManger.getJKAgentExcel(methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

exports.execgetInvoiceJsonExcel= function(methodParam){
    return new Promise(function(resolve,reject) {
       excelManger.getInvoiceJsonExcel(methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

exports.execGetSubCompanyDetails = function(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        utilManger.getSubComDetails(methodParam,tpoolconn, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

module.exports.execUnlock = execUnlock;
 module.exports.isTokenValid = isTokenValid;
 module.exports.cachedUrl = cachedUrl;