const coreDB = require('qaq-core-db');
const coreUtil = require('qaq-core-util');
var async = require("async");

exports.getSaveLedgerDtl = function(redirectParam, tpoolconn, callback) {
    var buyerIdn = redirectParam.buyerIdn || '';
    var coIdn = redirectParam.coIdn;
    let logUsr = redirectParam.logUsr;
    let acc_head = redirectParam.acc_head || '';
    let fctr = redirectParam.fctr || '';
    let entity = redirectParam.entity || '';
    let prefix = redirectParam.prefix || '';
    let buyer_terms_idn = redirectParam.buyer_terms_idn || '';
    let group_idn = redirectParam.group_idn || '';
    let buyerType = redirectParam.buyerType || '';

    let params = [];
    let fmt = {};
    let outJson = {};
    if (buyerIdn != '') {
        let sql = "select ledger_idn from acc_ledger  " +
            "where nme_ref_idn=$1  ";

        params.push(buyerIdn);
        // console.log(sql);
        // console.log(params);
        coreDB.executeTransSql(tpoolconn, sql, params, fmt, async function (error, result) {
            if (error) {
                outJson["status"] = "FAIL";
                outJson["message"] = "Error In getLedgerDtl Method!" + error.message;
                callback(null, outJson);
            } else {
                var len = result.rows.length;
                //console.log(len);
                if (len > 0) {
                    var resultRow = result.rows[0] || {};
                    outJson["ledger_idn"] = resultRow["ledger_idn"];
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    let methodParam = {};
                    methodParam["buyerIdn"] = buyerIdn;
                    methodParam["coIdn"] = coIdn;
                    methodParam["logUsr"] = logUsr;
                    methodParam["acc_head"] = acc_head;
                    methodParam["fctr"] = fctr;
                    methodParam["entity"] = entity;
                    methodParam["prefix"] = prefix;
                    methodParam["buyer_terms_idn"] = buyer_terms_idn;
                    methodParam["group_idn"] = group_idn;
                    methodParam["buyerType"] = buyerType;
                    let insertResult = await execInsertLedgerDtl(methodParam, tpoolconn);
                    callback(null, insertResult);
                }
            }
        });
    } else if (buyerIdn == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify buyerIdn Can not be blank!";
        callback(null, outJson);
    }
}

function execInsertLedgerDtl(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        insertLedgerDtl(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

function insertLedgerDtl(methodParam, tpoolconn, callback) {
    var buyerIdn = methodParam.buyerIdn || '';
    var coIdn = methodParam.coIdn;
    var logUsr = methodParam.logUsr;
    let acc_head = methodParam.acc_head || '';
    let fctr = methodParam.fctr || '';
    let entity = methodParam.entity || '';
    let prefix = methodParam.prefix || '';
    let buyer_terms_idn = methodParam.buyer_terms_idn || '';
    let group_idn = methodParam.group_idn || null;
    var cachedUrl = require('qaq-core-util').cachedUrl;
    let buyerType = methodParam.buyerType || '';

    let params = [];
    let fmt = {};
    let outJson = {};

    if (buyerIdn != '' && acc_head != '' && fctr != '' && entity != '') {
        let sqlQ = `select a.nme_idn,lower(a.nme) nme,initCap(a.nme) print,a.person_nme,a.address,a.attr,c.nme currency
                from nme_m a,buyer_terms b,gen_currency c where 
                a.nme_idn = b.nme_idn and b.currency_idn = c.currency_idn 
                and a.nme_idn=$1 and a.co_idn=$2 and a.stt=1 `;

        if(buyerType == 'broker' || buyerType == 'aadat'){
            sqlQ = `select a.nme_idn,lower(a.nme) nme,initCap(a.nme) print,a.person_nme,a.address,a.attr
                    from nme_m a where a.nme_idn=$1 and a.co_idn=$2 and a.stt=1 `;
        }

        params = [];
        params.push(buyerIdn);
        params.push(coIdn);
        let cnt = 2;
        if(buyer_terms_idn != ''){
            cnt++;
            sqlQ += " and b.buyer_terms_idn  =$"+cnt
            params.push(buyer_terms_idn);
        }
        //console.log(sqlQ)
        //console.log(params)
        coreDB.executeTransSql(tpoolconn, sqlQ, params, {},async function (error, result) {
            if (error) {
                outJson["status"] = "FAIL";
                outJson["message"] = "Fail To Execute Query! " + error.message;
                callback(null, outJson);
            } else {
                var len = result.rows.length;  
                var nmeDtlList = [];
                if (len > 0) {
                    let attrmdl = await coreUtil.getCache(prefix+"attributeModule",cachedUrl);
                    attrmdl=JSON.parse(attrmdl);
                    let ledgacc_attr =attrmdl.ledgacc_attr || {};
                    let ledg_attr = attrmdl.ledg_attr || {};
                    let accAttrList=ledgacc_attr["attrList"] || [];
                    let attrList=ledg_attr["attrList"] || [];

                    var nmeDtl = {};
                    var resultRow = result.rows[0];
                    nmeDtl["nme_idn"] = resultRow.nme_idn;
                    nmeDtl["nme"] = resultRow.nme;
                    nmeDtl["print"] = resultRow.print;
                    nmeDtl["address"] = resultRow.address;
                    let currency = resultRow.currency || '';
                    let typ = 'fe';
                    if(currency == 'INR'){
                        typ = 'default';
                    } 
                    if(buyerType == 'broker' || buyerType == 'aadat'){
                        typ = 'default';
                    }
                    let attr = resultRow.attr || {};
                    let accAttrMap = {};
                    for(let m=0;m<accAttrList.length;m++){
                        let attrStr = accAttrList[m];
                        accAttrMap[attrStr] = attr[attrStr] || '';
                    }
                    nmeDtl["acc_attr"] = accAttrMap;

                    let attrMap = {};
                    for(let m=0;m<attrList.length;m++){
                        let attrStr = attrList[m];
                        attrMap[attrStr] = attr[attrStr] || '';
                    }
                    attrMap["contact_person"] = resultRow.person_nme;
                    nmeDtl["attr"] = attrMap;
                    nmeDtlList.push(nmeDtl);

                    let insertQ = "insert into acc_ledger(sub_co_idn,acc_head,fctr,entity,pvt,stt,created_ts,created_by,typ,group_idn,nme_ref_idn,nme,print_nme,address,acc_attr,attr) \n" +
                    " select  $1 sub_co_idn,$2 acc_head,$3 fctr,$4 entity,0 pvt,1 stt,current_timestamp,$5 created_by,$6 typ,$7 group_idn,*   from jsonb_to_recordset('" + JSON.stringify(nmeDtlList) + "'::jsonb) \n"+
                    "as x(nme_idn numeric,nme varchar,print varchar,address jsonb,acc_attr jsonb, attr jsonb) RETURNING ledger_idn ";

                    params = [];
                    params.push(coIdn);
                    params.push(acc_head);
                    params.push(fctr);
                    params.push(entity);
                    params.push(logUsr);
                    params.push(typ);
                    params.push(group_idn);
                    //console.log(insertQ);
                    //console.log(params);
                    coreDB.executeTransSql(tpoolconn, insertQ, params, fmt, function (error, result) {
                        if (error) {
                            coreDB.doTransRollBack(tpoolconn);
                            outJson["status"] = "FAIL";
                            outJson["message"] = "Error In insertAccLedgers Method!" + error.message;
                            callback(null, outJson);
                        } else {
                            //coreDB.doTransCommit(tpoolconn);
                            var rowCount = result.rowCount;
                            if (rowCount > 0) {
                                var resultRow = result.rows[0] || {};
                                outJson["ledger_idn"] = resultRow["ledger_idn"];
                                outJson["status"] = "SUCCESS";
                                outJson["message"] = "Acc_ledger Inserted Sucessfully!";
                                callback(null, outJson);
                            } else {
                                //coreDB.doTransRollBack(tpoolconn);
                                outJson["status"] = "FAIL";
                                outJson["message"] = "Acc_ledger Inserted Failed!";
                                callback(null, outJson);
                            }
                        }
                    });
                } else {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Buyer Data not founds";
                    callback(null, outJson);    
                }
            }
        })
    } else if (buyerIdn == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify buyerIdn Can not be blank!";
        callback(null, outJson);
    }  else if (acc_head == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify acc_head Can not be blank!";
        callback(null, outJson);
    }  else if (fctr == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify fctr Can not be blank!";
        callback(null, outJson);
    } else if (entity == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify entity Can not be blank!";
        callback(null, outJson);
    }
}

exports.getAccLedgerDtl = function(connection,paramJson,callback){
    var coIdn = paramJson.coIdn;
    let sub_co_idn = paramJson.sub_co_idn;
    let ledgerNmeList = paramJson.ledgerNmeList;
    var outJson = {};
    let ledgerMap = {};

    let params = [sub_co_idn];
    let fmt = {};
    let query = "select ledger_idn,nme,print_nme,fctr,acc_head from acc_ledger  where " + 
        " sub_co_idn=$1 and stt=1 and nme in ('"+ledgerNmeList.join("','")+"') ";
    //console.log(query);
    //console.log(params);
    coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
        if(error){
            outJson["result"]='';
            outJson["status"]="FAIL";
            outJson["message"]="Get AccLedgerDtl Fail To Execute Query!"+error;
            callback(null,outJson);
        }else{
            var len = result.rows.length;
            //console.log("len",len)
            if(len>0){
                for(var k = 0 ;k<len;k++){
                    var resultRows = result.rows[k]; 
                    var params = {}; 
                    params["ledger_idn"] = resultRows.ledger_idn;
                    let nme =  resultRows.nme;
                    params["nme"] = nme;
                    params["print_nme"] = resultRows.print_nme;
                    params["fctr"] = resultRows.fctr;
                    params["acc_head"] = resultRows.acc_head;
                    ledgerMap[nme] = params;
                }
               
                outJson["status"]="SUCCESS";
                outJson["message"]="SUCCESS";
                outJson["ledgerMap"]=ledgerMap;
                callback(null,outJson);
            } else {
                outJson["status"]="FAIL";
                outJson["message"]="Sorry no result found";
                callback(null,outJson);
            }
        }
    })                        
}

exports.getAccSettLedgerDtl = function(connection,paramJson,callback){
    var coIdn = paramJson.coIdn;
    let sub_co_idn = paramJson.sub_co_idn;
    let ledgerNmeList = paramJson.ledgerNmeList || [];
    let settingsMap = paramJson.settingsMap || {};
    let settingAttr = Object.keys(settingsMap) || [];
    let settingAttrVal = Object.values(settingsMap) || [];
    var outJson = {};
    let ledgerMap = {};

    let params = [sub_co_idn];
    let fmt = {};
    let query = "select ledger_idn,nme,print_nme from acc_ledger  where " + 
        " sub_co_idn=$1 and stt=1 and print_nme in ('"+ledgerNmeList.join("','")+"') ";
    //console.log(query)
    coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
        if(error){
            outJson["result"]='';
            outJson["status"]="FAIL";
            outJson["message"]="Get AccLedgerDtl Fail To Execute Query!"+error;
            callback(null,outJson);
        }else{
            var len = result.rows.length;
            //console.log("len",len)
            if(len>0){
                for(var k = 0 ;k<len;k++){
                    var resultRows = result.rows[k]; 
                    let print_nme =  resultRows.print_nme;
                    if(settingAttrVal.indexOf(print_nme) > -1){
                        let attr = settingAttr[parseInt(settingAttrVal.indexOf(print_nme))] || '';
                        if(attr != '')
                            settingsMap[attr] =  resultRows.ledger_idn;
                    }    
                }
               
                outJson["status"]="SUCCESS";
                outJson["message"]="SUCCESS";
                outJson["result"]=settingsMap;
                callback(null,outJson);
            } else {
                outJson["status"]="FAIL";
                outJson["message"]="Sorry no result found";
                callback(null,outJson);
            }
        }
    })                        
}

exports.getNotes = function(connection,paramJson,callback){
    var coIdn = paramJson.coIdn;
    let sub_co_idn = paramJson.sub_co_idn;
    let likeStr = paramJson.likeStr || '';
    var outJson = {};
    let notesList = [];

    //if(journal_idn != ''){
    if(likeStr != ''){
        let params = [];
        params.push(coIdn);
        //params.push(journal_idn);
        let fmt = {};
        let query = "select notes_idn,notes,description from acc_notes \n"+
            "where co_idn=$1 and stt=1  \n"+//and $2 = any(journal_idn) 
            "and lower(notes) like lower('" + likeStr + "%') ";
            
        //console.log(query);
        //console.log(params)
        coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
            if(error){
                console.log(error);
                outJson["result"]='';
                outJson["status"]="FAIL";
                outJson["message"]="getNotes Fail To Execute Query!"+error;
                callback(null,outJson);
            }else{
                var len = result.rows.length;
                //console.log("len",len)
                if(len>0){
                    for(var k = 0 ;k<len;k++){
                        var resultRows = result.rows[k]; 
                        var map = {}; 
                        map["notes_idn"]= resultRows.notes_idn;
                        map["notes"] = resultRows.notes;
                        map["description"] = resultRows.description;
                        notesList.push(map);
                    }
                    notesList.sort((a, b) => (a.notes > b.notes ? 1 : -1));

                    outJson["status"]="SUCCESS";
                    outJson["message"]="SUCCESS";
                    outJson["result"]=notesList;
                    callback(null,outJson);
                } else {
                    outJson["status"]="FAIL";
                    outJson["message"]="Sorry no result found";
                    callback(null,outJson);
                }
            }
        }) 
    }   else if(likeStr ==''){
            outJson["status"]="FAIL";
            outJson["message"]="Please Verify likeStr Can not be blank!";
            callback(null,outJson);
    }
    //}else if(journal_idn == ''){
    //    outJson["status"]="FAIL";
    //    outJson["message"]="Please Verify Journal Idn Can not be blank!";
    //    callback(null,outJson);
    //}                    
}

exports.setLedgerBal = function(connection,paramJson,callback){
    let sub_co_idn = paramJson.sub_co_idn;
    let fin_year_idn = paramJson.fin_year_idn;
    let logUsr = paramJson.logUsr;
    let ledgerList = paramJson.ledgerList || [];
    var outJson = {};
    let ledgerListLen = ledgerList.length;
    //console.log("ledgerList",ledgerList);
    //console.log("ledgerListLen",ledgerListLen);

    if(ledgerListLen > 0){
        let tileWisearrayExec = [];
        for(let i=0;i<ledgerListLen;i++){
            let ledger_idn  = ledgerList[i];
            let paramJson={};
            paramJson["ledger_idn"] = ledger_idn;  
            paramJson["sub_co_idn"] = sub_co_idn; 
            paramJson["fin_year_idn"] = fin_year_idn; 
            paramJson["logUsr"] =logUsr;
            tileWisearrayExec.push(function (callback) { updateLedgerData(paramJson, connection,callback); });
        }
        async.parallel(tileWisearrayExec,async function (err, result) {
            if (err) {
                console.log(err);
                outJson["status"]="FAIL";
                outJson["message"]="Error In updateLedgerData Method!";
                callback(null,outJson);
            } else {
                outJson["status"]="SUCCESS";
                outJson["message"]="SUCCESS";
                callback(null,outJson);
            }
        }) 
    }   else if(ledgerListLen == 0){
            outJson["status"]="FAIL";
            outJson["message"]="Please Verify ledgerList Can not be blank!";
            callback(null,outJson);
    }                   
}

function updateLedgerData(methodParam, tpoolconn, callback) {
    let ledger_idn = methodParam.ledger_idn;
    let sub_co_idn = methodParam.sub_co_idn;
    let fin_year_idn = methodParam.fin_year_idn;
    let logUsr = methodParam.logUsr;

    let fmt = {};
    let params = [];
    let outJson = {};
    let sql = "select * from set_ledger_bal($1, $2, $3)";
    params.push(sub_co_idn);
    params.push(fin_year_idn);
    params.push(ledger_idn);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In set_ledger_bal Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "set_ledger_bal data not found";
                callback(null, outJson);
            }
        }
    })
}


exports.getSaleData = async function(connection,redirectParam,callback){
    let coIdn = redirectParam.coIdn;
    let sub_co_idn = redirectParam.sub_co_idn;
    let fin_year_idn = redirectParam.fin_year_idn;
    let entries_idn = redirectParam.entries_idn;
    let resultFinal = {};
    let outJson = {};
    let methodParam = {};

    methodParam = {};
    methodParam["coIdn"] = coIdn;
    methodParam["sub_co_idn"] = sub_co_idn;
    methodParam["fin_year_idn"] = fin_year_idn;
    methodParam["entries_idn"] = entries_idn;
    let headerResult = await execGetEntriesHdr(methodParam,connection);
    if(headerResult.status == 'SUCCESS'){
        resultFinal = headerResult["result"] || {};
        
        let detailResult = await execGetEntriesD(methodParam,connection);
        if(detailResult.status == 'SUCCESS'){
            resultFinal["dataTransList"] = detailResult["result"] || [];

            outJson["status"]="SUCCESS";
            outJson["message"]="SUCCESS";
            outJson["result"]=resultFinal;
            callback(null,outJson);
        } else {
            callback(null,detailResult);
        }
    } else {
        callback(null,headerResult);
    }
}

function execGetEntriesHdr(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        getEntriesHdr(tpoolconn,methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

function getEntriesHdr(connection,paramJson,callback){
    var coIdn = paramJson.coIdn;
    let sub_co_idn = paramJson.sub_co_idn;
    let entries_idn = paramJson.entries_idn || '';
    let fin_year_idn = paramJson.fin_year_idn;
    var outJson = {};

    if(entries_idn != ''){
        let params = [entries_idn,fin_year_idn,sub_co_idn];
        let fmt = {};
        let query = "select entries_idn,h.journal_idn,entry_srl,entry_title,aj.description nme, \n"+
            "to_char(h.trns_dt + interval '5.5 hours','yyyy-mm-dd') trns_dt, \n"+ 
            "bank_ref_idn, party_bank_ref , h.created_by ,addl_cr_ledger,addl_dr_ledger,\n"+
            "h.currency,exh_rte,bank_rte,custom_rte,weight,price_per_unit,total_amount,co_amount,discount,charges, \n"+
            "ref_trans_idn,ref_stock_idn,terms,dr_ledger_idn,cr_ledger_idn,notes,remarks,comments,h.attr,open_yn,rec_pay_ref \n"+
            "from acc_entries_h h,acc_journal aj where h.journal_idn = aj.journal_idn and h.entries_idn = $1  \n"+
            "and fin_year_idn= $2 and sub_co_idn = $3\n";
       
        //console.log(query)
        //console.log(params);
        coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
            if(error){
                outJson["result"]='';
                outJson["status"]="FAIL";
                outJson["message"]="getEntriesH Fail To Execute Query!"+error;
                callback(null,outJson);
            }else{
                var len = result.rows.length;
                //console.log("len",len)
                if(len>0){
                    let headerMap = {};
                    let data =  result.rows[0]; 
                    headerMap["entries_idn"]= data.entries_idn;
                    headerMap["journalIdn"] = data.journal_idn;
                    headerMap["journalNme"] = data.nme;
                    headerMap["entry_srl"] = data.entry_srl;
                    headerMap["entry_title"] = data.entry_title;
                    headerMap["transDte"] = data.trns_dt;
                    headerMap["exh_rte"] = data.exh_rte;
                    headerMap["currency"] = data.currency;
                    headerMap["bank_rte"] = data.bank_rte;
                    headerMap["custom_rte"] = data.custom_rte;
                    headerMap["co_amount"] = data.co_amount;
                    headerMap["total_Amount"] = data.total_amount;
                    headerMap["weight"] = data.weight;
                    headerMap["price_per_unit"] = data.price_per_unit;
                    headerMap["discount"] = data.discount;
                    headerMap["charges"] = data.charges;
                    headerMap["transactionIdnList"] = data.ref_trans_idn;
                    headerMap["stockIdnList"] = data.ref_stock_idn;
                    headerMap["notes"] = data.notes;
                    headerMap["attr"] = data.attr;
                    headerMap["remarks"] = data.remarks;
                    headerMap["comments"] = data.comments;
                    let terms = data.terms || {};
                    headerMap["terms"] = terms["termsDtl"] || [];
                    headerMap["crLedgerIdnList"] = data.addl_cr_ledger;
                    headerMap["drLedgerIdnList"] = data.addl_dr_ledger;
                    headerMap["bank_ref_idn"] =data.bank_ref_idn;
                    headerMap["party_bank_ref"] = data.party_bank_ref;
                    let rec_pay_ref = data.rec_pay_ref || {};
                    var rec_pay_refKeys=Object.keys(rec_pay_ref) || [];
                    headerMap["rec_pay_ref"] = rec_pay_ref;
                    headerMap["created_by"] = data.created_by;
                    headerMap["dr_ledger_idn"] = data.dr_ledger_idn;
                    headerMap["cr_ledger_idn"] = data.cr_ledger_idn;

                    outJson["status"]="SUCCESS";
                    outJson["message"]="SUCCESS";
                    outJson["result"]=headerMap;
                    outJson["rec_pay_refKeys"] = rec_pay_refKeys;
                    callback(null,outJson);
                } else {
                    outJson["status"]="FAIL";
                    outJson["message"]="Sorry no result found";
                    callback(null,outJson);
                }
            }
        }) 
    }else if(entries_idn ==''){
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Entries Idn Can not be blank!";
        callback(null,outJson);
    }                     
}

function execGetEntriesD(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        getEntriesD(tpoolconn,methodParam, function (error, result) {
            if(error){  
            reject(error);
            }
            resolve(result);
        });
    });
}

function getEntriesD(connection,paramJson,callback){
    var coIdn = paramJson.coIdn;
    let sub_co_idn = paramJson.sub_co_idn;
    let entries_idn = paramJson.entries_idn || '';
    let fin_year_idn = paramJson.fin_year_idn;
    var outJson = {};
    let dtlList = [];

    if(entries_idn != ''){
        let params = [entries_idn,fin_year_idn,sub_co_idn];
        let fmt = {};
        let query = "select d.entries_d_idn,d.ledger_idn,d.dtl_srt,d.typ,d.fctr,al.print_nme,\n"+
            "to_char(d.trns_dt + interval '5.5 hours','yyyy-mm-dd') trns_dt, \n"+
            "d.currency,d.exh_rte,d.bank_rte,d.custom_rte,d.entry_amount,d.co_amount, \n"+
            "d.open_yn,d.received_amount,d.short_amount,d.notes,d.remarks dtlremark,h.remarks hdrremark,d.comments \n"+
            "from acc_entries_h h,acc_entries_d d,acc_ledger al \n"+
            "where h.entries_idn=d.entries_idn and d.ledger_idn=al.ledger_idn \n"+
            " and  h.entries_idn = $1 and al.sub_co_idn=h.sub_co_idn \n"+
            "and h.fin_year_idn= $2 and h.sub_co_idn = $3 and d.co_amount != 0 and d.entry_amount <> d.co_amount order by d.co_amount desc,d.fctr desc \n";
       
        //console.log(query)
        //console.log(params);
        coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
            if(error){
                outJson["result"]='';
                outJson["status"]="FAIL";
                outJson["message"]="getEntriesD Fail To Execute Query!"+error;
                callback(null,outJson);
            }else{
                var len = result.rows.length;
                //console.log("len",len)
                if(len>0){
                    for(var k=0;k<len;k++){
                        var resultRows = result.rows[k]; 
                        var map = {}; 
                        map["entries_d_idn"] = resultRows.entries_d_idn;
                        map["ledger_idn"] = resultRows.ledger_idn;
                        map["ledgerNme"] = resultRows.print_nme;
                        map["dtl_srt"] = resultRows.dtl_srt;
                        map["typ"] = resultRows.typ;
                        map["fctr"] = resultRows.fctr;
                        map["trns_dt"] = resultRows.trns_dt;
                        map["currency"] = resultRows.currency;
                        map["exh_rte"] = resultRows.exh_rte;
                        map["bank_rte"] = resultRows.bank_rte;
                        map["custom_rte"] = resultRows.custom_rte;
                        map["entry_amount"] = resultRows.entry_amount;
                        map["co_amount"] = resultRows.co_amount;
                        map["open_yn"] = resultRows.open_yn;
                        map["received_amount"] = resultRows.received_amount;
                        map["short_amount"] = resultRows.short_amount;
                        map["notes"] = resultRows.notes;
                        let dtlremark = resultRows.dtlremark || '';
                        let hdrremark = resultRows.hdrremark || '';
                        let remarks = hdrremark;
                        if(remarks == '')
                            remarks = dtlremark;
                        map["remarks"] = remarks;
                        map["comments"] = resultRows.comments;
                        dtlList.push(map);       
                    }

                    outJson["status"]="SUCCESS";
                    outJson["message"]="SUCCESS";
                    outJson["result"]=dtlList;
                    callback(null,outJson);
                } else {
                    outJson["status"]="FAIL";
                    outJson["message"]="Sorry no result found";
                    callback(null,outJson);
                }
            }
        }) 
    }else if(entries_idn ==''){
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Entries Idn Can not be blank!";
        callback(null,outJson);
    }                     
}

exports.getStateByCity = function(paramJson,connection,callback) {
    var city_nm = paramJson.city_nm;
    let outJson = {};

    if(city_nm != ''){
        let fmt = {};
        let params=[];
    
        var sql="select b.name from cities a ,states b \n"+
            "where a.state_idn = b.state_idn and lower(a.name) = lower('"+city_nm+"')";

         //console.log(sql);
        // console.log(params);
        coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
            if(error){
                console.log(error);
                outJson["status"]="FAIL";
                outJson["message"]="Error In getStateByCity Method!";
                callback(null,outJson);
            }else{
                var len=result.rows.length;
                if(len>0){
                    let state_nm = result.rows[0].name || '';

                    outJson["result"]=state_nm;
                    outJson["status"]="SUCCESS";
                    outJson["message"]="SUCCESS";
                    callback(null,outJson);
                }else{
                    outJson["status"]="FAIL";
                    outJson["message"]="State data not found";
                    callback(null,outJson);
                }
            }
        });
    }else if(city_nm ==''){
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify City Name Can not be blank!";
        callback(null,outJson);
    }   
}


exports.getSignatoryNmeDtl = function(connection,paramJson,callback) {
    let coIdn = paramJson.coIdn;
    let prefix = paramJson.prefix || '';
    let fmt = {};
    let params=[];
    let outJson = {};
    let list = [];

    var sql=`select nme_idn,upper(nme) nme, attr->>'sign_title' title
        from nme_m where co_idn= $1 and stt= 1 
        and attr->>'sign_title' != 'na' `;
    params.push(coIdn);

    // console.log(sql);
    // console.log(params);
    coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
        if(error){
            outJson["status"]="FAIL";
            outJson["message"]="Error In getSignatoryNmeDtl Method!"+error.message;
            callback(null,outJson);
        }else{
            var len=result.rows.length;
            if(len>0){
                var cachedUrl = require('qaq-core-util').cachedUrl;

                coreUtil.getCache(prefix+"attributeMasterDtl_" + coIdn, cachedUrl).then(attributeMasterDtl => {
                    if (attributeMasterDtl == null) {
                        outJson["status"] = "FAIL";
                        outJson["message"] = "Fail to get Application AttributeDtl";
                        callback(null, outJson);
                    } else {
                        attributeMasterDtl = JSON.parse(attributeMasterDtl);
                        let attr = "sign_title";
                        let prpVal = attributeMasterDtl[attr + "#V"] || [];
                        let prpPrint = attributeMasterDtl[attr + "#P"] || [];
                        for(var i=0;i<len;i++){
                            let map = {};
                            let resultRows = result.rows[i];
                            map["nme_idn"] = resultRows.nme_idn;
                            map["nme"] = resultRows.nme;
                            let title = resultRows.title || '';
                            title = prpPrint[prpVal.indexOf(title)] || '';
                            map["title"] = title;

                            list.push(map);
                        }

                        outJson["status"] = "SUCCESS";
                        outJson["message"] = "SUCCESS";
                        outJson["result"] = list;
                        callback(null,outJson);
                    }
                })
            }else{
                outJson["status"] = "FAIL";
                outJson["message"] = "Name Signatory data not found";
                outJson["result"] = list;
                callback(null,outJson);
            }
        }
    })
}
