
const coreDB = require('qaq-core-db');


exports.updateAccessLog = function(paramJson,callback){
    var log_idn = paramJson.log_idn || '';
    var pg_name = paramJson.pg_name || '';
    var req_method = paramJson.req_method || '';
    var req_data = paramJson.req_data || '';
    var res_data = paramJson.res_data || '';
    var connection = paramJson.db || '';
    var access_log_idn = paramJson.access_log_idn || '';
    var outJson = {};

    if(connection != '' && log_idn != '' && pg_name != '' && req_method != '' && (req_data != '' || res_data != '')){
        if(access_log_idn != ''){
            var params = [access_log_idn];
            var fmt = {};
            //var query = "update appl_access_log set data = jsonb_set(data, '{\"responseData\"}',$2),response_ts=now() where access_log_idn = $1";
            var query = "update appl_access_log set response_data = response_data || concat('{\"responseData\":','"+ JSON.stringify(res_data)+"', '}')::jsonb,response_ts=now() where access_log_idn = $1";
            //console.log(query);
            //console.log(params);
            coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
                if(error){
                    coreDB.doTransRollBack(connection);
                    outJson["result"]='';
                    outJson["status"]="FAIL";
                    outJson["message"]="Get Update Access Log Fail To Execute Query!";
                    callback(null,outJson);
                }else{
                    //coreDB.doTransCommit(connection);
                    var rowCount = result.rowCount;
                
                    if(rowCount>0){
                        outJson["result"]="";
                        outJson["status"]="SUCCESS";
                        outJson["message"]="Application Access Log Updated Successfully";
                        callback(null,outJson);
                    }else{
                        outJson["result"]="";
                        outJson["status"]="FAIL";
                        outJson["message"]="Access Log Not Updated";
                        callback(null,outJson);
                    }
                }
            });
        }else{
            var params={};
            params["seqNm"] = "appl_access_log_seq";
            getNextValFromSeq(connection,params,function(error,seqresult){
                var logDtls = seqresult;
                var status = logDtls["status"];
                if(status == "SUCCESS"){
                    var logId = logDtls["result"];  
                    var param ={};
                    param["requestData"]= req_data;
                    //param["responseData"]= {};                         
                    var paramms = [logId,log_idn,pg_name,req_method,param];
                    fmt = {};
                    var insLogQ = " insert into appl_access_log(access_log_idn,log_idn,form_nme,request_method,request_ts,data) values($1,$2,$3,$4,now(),$5)";
                    
                    coreDB.executeTransSql(connection,insLogQ,paramms,fmt,function(error,result){
                        if(error){
                            coreDB.doTransRollBack(connection);                       
                            outJson["result"]='';
                            outJson["status"]="FAIL";
                            outJson["message"]="Insert Access Log Id Fail To Execute Query!";
                            callback(null,outJson);
                        }else{
                            //coreDB.doTransCommit(connection);
                            var rowCount = result.rowCount;
                            //console.log("rowCount"+rowCount);
                            if(rowCount>0){
                                var logDtl = {};
                                logDtl["LOGID"]=logId;
                                outJson["result"]=logDtl;
                                outJson["status"]="SUCCESS";
                                outJson["message"]="SUCCESS";
                                callback(null,outJson);
                            }else{
                                outJson["result"]="";
                                outJson["status"]="FAIL";
                                outJson["message"]="Access Log Not Inserted";
                                callback(null,outJson);
                            }
                        }
                    });
                }
            })
        }             
    }else if(connection == ''){
         outJson["result"]='';
         outJson["status"]="FAIL";
         outJson["message"]="Please Verify DB Parameter";
         callback(null,outJson);
    }else if(log_idn == ''){
         outJson["result"]='';
         outJson["status"]="FAIL";
         outJson["message"]="Please Verify Login Idn  Parameter";
         callback(null,outJson);
    }else if(pg_name == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Page Name Parameter";
        callback(null,outJson);
    }else if(req_method == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Request Method Parameter";
        callback(null,outJson);
    }else if((req_data == '' || res_data == '')){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Request Data/Response Data Parameter";
        callback(null,outJson);
    }
}

function getNextValFromSeq(connection,paramJson,callback){
    var seqNm = paramJson.seqNm || '';
    var outJson = {};
    if(seqNm != ''){  
        var params = [seqNm];
        var fmt = {};
        var query = "SELECT nextval($1) seq";
        coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
            if(error){
                outJson["result"]='';
                outJson["status"]="FAIL";
                outJson["message"]="Get Seq Fail To Execute Query!";
                callback(null,outJson);
            }else{
                if(result.rowCount > 0){
                    var seq = result.rows[0].seq;
                    // console.log("seq"+seq);
                    outJson["result"]=seq;
                    outJson["status"]="SUCCESS";
                    outJson["message"]="SUCCESS";
                    callback(null,outJson);
                }else{
                    outJson["result"]="";
                    outJson["status"]="FAIL";
                    outJson["message"]="Fail to get Sequence";
                    callback(null,outJson);
                }
            }
        });               
    }else if(seqNm == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Sequence Name Parameter";
        callback(null,outJson);
    }
}


exports.saveMailLog = function(paramJson,connection,callback){
    var coIdn = paramJson.coIdn || '';
    var emp_idn = paramJson.emp_idn || '';
    var nme_idn = paramJson.nme_idn || '';
    var auto_yn = paramJson.auto_yn || 1;
    var channel = paramJson.channel || 'Email';
    var subject = paramJson.subject || '';
    var summary = paramJson.summary || '';
    var details = paramJson.details || '';
    var status = paramJson.status || '';
    var remarks = paramJson.remarks || '';
    var pvt = paramJson.pvt || 0;
    var logUsr = paramJson.logUsr || '';
    let recipientListMap = paramJson.recipientListMap || {};
    let attrMap = paramJson.attrMap || {};
    let log_ts = paramJson.log_ts || '';
    let format_idn = paramJson.format_idn || null;
    if(log_ts != ''){
        log_ts = "to_date('"+log_ts+"','yyyy-mm-dd')";
    }else{
        log_ts = "current_timestamp";
    }

    var outJson = {};

    if(coIdn != '' && subject != '' && summary != '' && details != '' && nme_idn != '' && emp_idn != ''){                        
        let params = [coIdn,emp_idn,nme_idn,auto_yn,channel,subject,summary,details,status,remarks,pvt,logUsr,format_idn];
        let fmt = {};
        var insLogQ = "insert into communication_log(co_idn,log_ts,emp_idn,nme_idn,auto_yn, \n"+
                "channel,subject,summary,details,status,remarks,stt,pvt,created_ts,created_by,recipient_list,attr,format_idn) \n"+
                "values($1,"+log_ts+",$2,$3,$4,$5,$6,$7,$8,$9,$10,1,$11,current_timestamp,$12,'" + JSON.stringify(recipientListMap) + "','" + JSON.stringify(attrMap) + "',$13)";
        
                //console.log(insLogQ);
        coreDB.executeTransSql(connection,insLogQ,params,fmt,function(error,result){
            if(error){
                console.log(error);                     
                outJson["result"]='';
                outJson["status"]="FAIL";
                outJson["message"]="Insert Communication Log  Fail To Execute Query!";
                callback(null,outJson);
            }else{
                var rowCount = result.rowCount;
                //console.log("rowCount"+rowCount);
                if(rowCount>0){  
                    outJson["status"]="SUCCESS";
                    outJson["message"]="SUCCESS";
                    callback(null,outJson);
                }else{
                    outJson["status"]="FAIL";
                    outJson["message"]="Communication Log Not Inserted";
                    callback(null,outJson);
                }
            }
        });            
    }else if(coIdn == ''){
         outJson["result"]='';
         outJson["status"]="FAIL";
         outJson["message"]="Please Verify coIdn Parameter";
         callback(null,outJson);
    }else if(subject == ''){
         outJson["result"]='';
         outJson["status"]="FAIL";
         outJson["message"]="Please Verify Subject  Parameter";
         callback(null,outJson);
    }else if(summary == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Summary Parameter";
        callback(null,outJson);
    }else if(details == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Details Parameter";
        callback(null,outJson);
    }else if(nme_idn == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Name Idn Parameter";
        callback(null,outJson);
    }else if(emp_idn == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Emp Idn Parameter";
        callback(null,outJson);
    }
}


