const coreDB = require('qaq-core-db');
const coreUtil = require('qaq-core-util');
var dateFormat = require('dateformat');
var replaceall = require("replaceall");
var async = require("async");
var ceil = require('math-ceil');

exports.updateSearchIdn = function (params, tpoolconn, callback) {
    let count = params.count;
    let searchIdn = params.searchIdn;
    let pgfmt = {};
    let pgparams = [];
    var outJson = {};
    var sql = "update stock_search set response_ts=current_timestamp,response_cnt=$1 where search_id=$2";
    pgparams.push(count);
    pgparams.push(searchIdn);
    // console.log(sql);
    // console.log(pgparams);
    coreDB.executeTransSql(tpoolconn, sql, pgparams, pgfmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;
            callback(null, outJson);
        } else {
            //coreDB.doTransCommit(tpoolconn);
            var rowCount = result.rowCount;
            if (rowCount > 0) {
                outJson["message"] = "Search Idn Updated Sucessfully";
                outJson["status"] = "SUCCESS";
            } else {
                outJson["message"] = "Fail To Update Search Id!";
                outJson["status"] = "FAIL";
            }
            callback(null, outJson);
        }
    });
}

exports.getSearchIdn = function (methodParam, tpoolconn, callback) {
    // console.log('test');get
    var attrType = methodParam.attrType || '';
    var attr = methodParam.attr || '';
    var attrVal = methodParam.attrVal || '';
    var buyerIdn = methodParam.buyerIdn;
    var empIdn = methodParam.empIdn;
    var buyerTermsIdn = methodParam.buyerTermsIdn;
    var searchIdn = methodParam.searchIdn || '';
    var statusList = methodParam.statusList || [];
    var source = methodParam.source;
    var logUsr = methodParam.logUsr;
    var foogleStr = methodParam.foogleStr || '';
    var coIdn = methodParam.coIdn || '';
    let fmt = {};
    let params = [];
    let sqlQ = "";
    let outJson = {};
    params.push(buyerTermsIdn);
    params.push(foogleStr);
    params.push(source);
    params.push(attr);
    params.push(attrVal);
    params.push(attrType);
    params.push(logUsr);
    if (searchIdn == 0 || searchIdn == '') {
        sqlQ = "insert into stock_search(buyer_terms_idn,request_foogle_str,request_src,request_ts,request_attr,request_attrval,request_attrtyp,request_status,created_by,co_idn) \n" +
            "values($1,$2,$3,current_timestamp,$4,$5,$6,'{" + statusList.join() + "}',$7,$8)";
        params.push(coIdn);
    } else {
        sqlQ = "update stock_search set buyer_terms_idn=$1,request_foogle_str=$2,request_src=$3,modified_ts=current_timestamp,request_attr=$4,request_attrval=$5,request_attrtyp=$6 \n";
        if(statusList.length > 0)
            sqlQ +=",request_status='{" + statusList.join() + "}' \n";

        sqlQ +=" ,modified_by=$7 where search_id=$8";
    }

    if (searchIdn != 0 || searchIdn != '')
        params.push(searchIdn);

    sqlQ += " RETURNING search_id";
    //console.log("sql",sqlQ);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sqlQ, params, fmt,async function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;;
            callback(null, outJson);
        } else {
            //coreDB.doTransCommit(tpoolconn);
            var rowCount = result.rowCount;
            if (rowCount > 0) {
                var resultRow = result.rows[0] || {};
                let search_id = resultRow["search_id"] || '';
                outJson["status"] = "SUCCESS";
                if (searchIdn == 0 || searchIdn == '')
                    outJson["message"] = "Search Idn Created Sucessfully";
                else
                    outJson["message"] = "Search Idn Updated Sucessfully";
                outJson["searchIdn"] = search_id;
                callback(null, outJson);
            } else {
                if (searchIdn != 0 || searchIdn != ''){
                    let searchResult = await execSaveStockSearch(methodParam,tpoolconn);
                    callback(null,searchResult);
                } else {
                    outJson["status"] = "FAIL";
                    if (searchIdn == 0 || searchIdn == '')
                        outJson["message"] = "Fail To Create Search Id!";
                    else
                        outJson["message"] = "Fail To Update Search Id!";
                    callback(null, outJson);
                }
            }   
        }
    });
}

function execSaveStockSearch(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        saveStockSearch(methodParam, tpoolconn, function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

function saveStockSearch(methodParam, tpoolconn, callback) {
    var attrType = methodParam.attrType || '';
    var attr = methodParam.attr || '';
    var attrVal = methodParam.attrVal || '';
    var buyerIdn = methodParam.buyerIdn;
    var empIdn = methodParam.empIdn;
    var buyerTermsIdn = methodParam.buyerTermsIdn;
    var searchIdn = methodParam.searchIdn || '';
    var statusList = methodParam.statusList || [];
    var source = methodParam.source;
    var logUsr = methodParam.logUsr;
    var foogleStr = methodParam.foogleStr || '';
    var coIdn = methodParam.coIdn || '';
    let fmt = {};
    let params = [];
    let sqlQ = "";
    let outJson = {};
    params.push(buyerTermsIdn);
    params.push(foogleStr);
    params.push(source);
    params.push(attr);
    params.push(attrVal);
    params.push(attrType);
    params.push(logUsr);
    sqlQ = "insert into stock_search(buyer_terms_idn,request_foogle_str,request_src,request_ts,request_attr,request_attrval,request_attrtyp,request_status,created_by,co_idn,search_id) \n" +
            "values($1,$2,$3,current_timestamp,$4,$5,$6,'{" + statusList.join() + "}',$7,$8,$9)";
    params.push(coIdn);
    params.push(searchIdn);

    sqlQ += " RETURNING search_id";
    //console.log(sqlQ);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sqlQ, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;;
            callback(null, outJson);
        } else {
            //coreDB.doTransCommit(tpoolconn);
            var rowCount = result.rowCount;
            if (rowCount > 0) {
                var resultRow = result.rows[0] || {};
                let search_id = resultRow["search_id"] || '';
                outJson["status"] = "SUCCESS";
                if (searchIdn == 0 || searchIdn == '')
                    outJson["message"] = "Search Idn Created Sucessfully";
                else
                    outJson["message"] = "Search Idn Updated Sucessfully";
                outJson["searchIdn"] = search_id;
                //console.log(outJson);
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                if (searchIdn == 0 || searchIdn == '')
                    outJson["message"] = "Fail To Create Search Id!";
                else
                    outJson["message"] = "Fail To Update Search Id!";
                    //console.log(outJson);
                callback(null, outJson);
            }
        }
    });
}

exports.getSearchPackets = function (methodParam, tpoolconn, callback) {
    let searchIdn = methodParam.searchIdn;
    let buyerIdn = methodParam.buyerIdn;
    let buyerTermsIdn = methodParam.buyerTermsIdn;
    let empIdn = methodParam.empIdn;
    let coIdn = methodParam.coIdn;
    let where_query_str = methodParam.where_query_str;
    let resultView = methodParam.resultView;
    let prefix = methodParam.prefix || '';
    let fmt = {};
    let params = [];
    let outJson = {};
    let pktIdnList = [];
    let pktDtl = {};
    let searchResultDtl = {};
    let resultViewlength = resultView.length;
    let dataTypeFormatDtl = {};
    let attrDisplayDtl = {};
    var cachedUrl = require('qaq-core-util').cachedUrl;
    coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
        if (productAttributeM == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Product Attribute";
            callback(null, outJson);
        } else {
            productAttributeM = JSON.parse(productAttributeM);

            for (let j = 0; j < resultViewlength; j++) {
                let attr = resultView[j];
                let data_typ = productAttributeM[attr + "#T"] || '';
                let display = productAttributeM[attr + "#DS"] || '';
                let format = productAttributeM[attr + "#F"] || '';
                dataTypeFormatDtl[attr] = data_typ;
                dataTypeFormatDtl[attr + "#F"] = format;
                attrDisplayDtl[attr] = display;
            }

            attrDisplayDtl["dsp_stt"] = "Status";
            outJson["attrDisplayDtl"] = attrDisplayDtl;
            coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                if (productAttributeDtl == null) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to get Product Sub Attribute";
                    callback(null, outJson);
                } else {
                    productAttributeDtl = JSON.parse(productAttributeDtl);



                    let insertSqlQ = "create temp table if not exists temp_stock_search_pkts as \n" +
                        "select " + searchIdn + " \n" +
                        "from stock_m\n" +
                        "where " + where_query_str;
                    insertSqlQ += " and co_idn=$1 and stt= 1 ";
                    params = [];
                    params.push(coIdn);
                    coreDB.executeTransSql(tpoolconn, insertSqlQ, params, fmt, function (error, result) {
                        if (error) {
                            outJson["status"] = "FAIL";
                            outJson["message"] = "Fail To Execute getSearchPackets Function Query! " + error.message;
                            callback(null, outJson);
                        } else {
                            var rowCount = result.rowCount;
                            if (rowCount > 0) {
                                let selectQ = getSelectQ(resultView);
                                let sql = "select " + selectQ +
                                    " from temp_stock_search_pkts ";
                                sql += " order by sort"
                                params = [];
                                // console.log(sql);
                                coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
                                    if (error) {
                                        outJson["status"] = "FAIL";
                                        outJson["message"] = "Error In select Stock_m Packets Method!" + error.message;
                                        // console.log(outJson);
                                        callback(null, outJson);
                                    } else {
                                        var len = result.rows.length;
                                        if (len > 0) {
                                            for (let i = 0; i < len; i++) {
                                                var resultRow = result.rows[i];
                                                pktDtl = {};
                                                let pkt_idn = resultRow["pkt_idn"];
                                                let stock_type = resultRow["stock_type"];
                                                pktDtl["pkt_idn"] = pkt_idn;
                                                pktDtl["pkt_code"] = resultRow["pkt_code"];
                                                pktDtl["stock_type"] = stock_type;
                                                pktDtl["status"] = resultRow["status"];
                                                pktDtl["benchmark_rte"] = resultRow["benchmark_rte"];
                                                pktDtl["qty_on_hand"] = resultRow["qty_on_hand"];
                                                pktDtl["weight_on_hand"] = resultRow["weight_on_hand"];
                                                pktDtl["asking_rte"] = resultRow["asking_rte"];
                                                pktDtl["sort"] = resultRow["sort"];
                                                pktDtl["dsp_stt"] = resultRow["dsp_stt"];
                                                pktDtl["dsp_stt_color"] = resultRow["dsp_stt_color"];
                                                for (let j = 0; j < resultViewlength; j++) {
                                                    let attr = resultView[j];
                                                    let data_typ = dataTypeFormatDtl[attr] || '';
                                                    let attrVal = resultRow[attr];
                                                    if (data_typ == 'c' && attrVal != '' && attrVal != 0) {
                                                        let prpSort = productAttributeDtl[attr + "#S"] || [];
                                                        let prpDisplay = productAttributeDtl[attr + "#P"] || [];
                                                        attrVal = prpDisplay[prpSort.indexOf(parseInt(attrVal))];
                                                    } else if (data_typ == 'd' && attrVal != '' && attrVal != 0) {
                                                        attrVal = getDateyyyymmddToExpected(attrVal, 'dd-mmm-yyyy');
                                                    } else if (data_typ == 'n' && attrVal != '' && attrVal != 0) {
                                                        let format = dataTypeFormatDtl[attr + "#F"] || 'N';
                                                        if (format != '') {
                                                            if (stock_type != 'NR' && attr == "crtwt") {
                                                                format = 3;
                                                            }
                                                            attrVal = attrVal || 0;
                                                            attrVal = floorFigure(attrVal, format);
                                                        }
                                                    }
                                                    pktDtl[attr] = attrVal;
                                                }
                                                searchResultDtl[pkt_idn] = pktDtl;
                                                pktIdnList.push(pkt_idn);
                                            }
                                            // console.log(searchResultDtl);
                                            outJson["pktIdnList"] = pktIdnList;
                                            outJson["searchResultDtl"] = searchResultDtl;
                                            outJson["status"] = "SUCCESS";
                                            outJson["message"] = "SUCCESS";
                                        } else {
                                            outJson["status"] = "SUCCESS";
                                            outJson["message"] = "Sorry No Result Found";
                                        }
                                        callback(null, outJson);
                                    }
                                });
                            } else {
                                outJson["message"] = "Sorry No Result Found!";
                                outJson["status"] = "SUCCESS";
                                callback(null, outJson);
                            }

                        }
                    });
                }
            });
        }
    });

}

exports.getSearchPacketsStock = function (methodParam, tpoolconn, callback) {
    let searchIdn = methodParam.searchIdn;
    let buyerIdn = methodParam.buyerIdn;
    let buyerTermsIdn = methodParam.buyerTermsIdn;
    let empIdn = methodParam.empIdn;
    let coIdn = methodParam.coIdn;
    let source = methodParam.source;
    let where_query_str = methodParam.where_query_str;
    let resultView = methodParam.resultView;
    let pktIdnWise = methodParam.pktIdnWise || "yes";
    let prefix = methodParam.prefix || '';
    let fmt = {};
    let params = [];
    let outJson = {};
    let pktIdnList = [];
    let pktDtl = {};
    let searchResultDtl = {};
    let resultViewlength = resultView.length;
    let dataTypeFormatDtl = {};
    let attrDisplayDtl = {};
    let formulaAttr = [];
    let searchResultList = [];
    var cachedUrl = require('qaq-core-util').cachedUrl;
    coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
        if (productAttributeM == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Product Attribute";
            callback(null, outJson);
        } else {
            productAttributeM = JSON.parse(productAttributeM);

            for (let j = 0; j < resultViewlength; j++) {
                let attr = resultView[j];
                let data_typ = productAttributeM[attr + "#T"] || '';
                let display = productAttributeM[attr + "#DS"] || '';
                let web = productAttributeM[attr + "#W"] || '';
                let format = productAttributeM[attr + "#F"] || '';
                let formula = productAttributeM[attr + "#FL"] || '';
                dataTypeFormatDtl[attr] = data_typ;
                dataTypeFormatDtl[attr + "#F"] = format;
                dataTypeFormatDtl[attr + "#FL"] = formula;
                if (data_typ == 'f') {
                    formulaAttr.push(attr);
                    if (formula != '')
                        dataTypeFormatDtl[attr + "#FL#ATTR"] = getDependAttrList(formula);
                }
                attrDisplayDtl[attr] = display;
                // if(source=='qsol' || source=='qs')
                // attrDisplayDtl[attr]=display;
                // else
                // attrDisplayDtl[attr]=web;
            }

            attrDisplayDtl["dsp_stt"] = "Status";
            outJson["attrDisplayDtl"] = attrDisplayDtl;
            coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                if (productAttributeDtl == null) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to get Product Sub Attribute";
                    callback(null, outJson);
                } else {
                    productAttributeDtl = JSON.parse(productAttributeDtl);



                    let selectQ = getSelectDirectQ(resultView);
                    let sql = "select " + selectQ + "  , attr->> 'rap_rte' raprte , attr ->> 'fancy_co' fancyco,attr->> 'lot' lot   from stock_m where " + where_query_str + " order by sort";
                    params = [];
                    //console.log(sql);
                    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
                        if (error) {
                            outJson["status"] = "FAIL";
                            outJson["message"] = "Error In select Stock_m Packets Method!" + error.message;
                            // console.log(outJson);
                            callback(null, outJson);
                        } else {
                            var len = result.rows.length;
                            if (len > 0) {
                                for (let i = 0; i < len; i++) {
                                    var resultRow = result.rows[i];
                                    pktDtl = {};
                                    let pkt_idn = resultRow["pkt_idn"];
                                    let stock_type = resultRow["stock_type"];
                                    var rapRte=parseInt(resultRow['raprte']||'1');

                                    pktDtl["pkt_idn"] = "" + pkt_idn + "";
                                    pktDtl["pkt_code"] = "" + resultRow["pkt_code"] + "";
                                    pktDtl["stock_type"] = stock_type;
                                    pktDtl["status"] = resultRow["status"];
                                    pktDtl["benchmark_rte"] = "" + resultRow["benchmark_rte"] + "";
                                    pktDtl["qty_on_hand"] = "" + resultRow["qty_on_hand"] + "";
                                    pktDtl["weight_on_hand"] = "" + resultRow["weight_on_hand"] + "";
                                    pktDtl["asking_rte"] = "" + resultRow["asking_rte"] + "";
                                    pktDtl["sort"] = resultRow["sort"];
                                    pktDtl["dsp_stt"] = resultRow["dsp_stt"];
                                    pktDtl["dsp_stt_color"] = resultRow["dsp_stt_color"];
                                    pktDtl["lot_no"] = resultRow["lot"];
                                    for (let j = 0; j < resultViewlength; j++) {
                                        let attr = resultView[j];
                                        let data_typ = dataTypeFormatDtl[attr] || '';
                                        let attrVal = resultRow[attr] || '';
                                        if (data_typ == 'c' && attrVal != '' && attrVal != 0) {
                                            let prpSort = productAttributeDtl[attr + "#S"] || [];
                                            let prpDisplay = productAttributeDtl[attr + "#P"] || [];
                                            let prpWeb = productAttributeDtl[attr + "#W"] || [];
                                            let prpVal=productAttributeDtl[attr+"#V"] || [];
                                            let tingeValue = '';
                                            if(attr == 'tinge'){
                                               let tingeVal=prpVal[prpSort.indexOf(parseInt(attrVal))] || '';
                                               if(tingeVal == 'na'){
                                                    let coVal = resultRow["co"] || '';
                                                    //console.log("coVal",coVal);
                                                    let coSort=productAttributeDtl["co#S"] || [];
                                                    let coDisplay=productAttributeDtl["co#P"] || [];
                                                    let minVal = "D++";
                                                    let maxVal = "H--";
                                                    minVal = coSort[coDisplay.indexOf(minVal)];
                                                    maxVal = coSort[coDisplay.indexOf(maxVal)];

                                                    let minVal1 = "I++";
                                                    let maxVal1 = "J--";
                                                    minVal1 = coSort[coDisplay.indexOf(minVal1)];
                                                    maxVal1 = coSort[coDisplay.indexOf(maxVal1)];

                                                    let minVal2 = "K++";
                                                    let maxVal2 = "M--";
                                                    minVal2 = coSort[coDisplay.indexOf(minVal2)];
                                                    maxVal2 = coSort[coDisplay.indexOf(maxVal2)];
                                                    //console.log("minVal2",minVal2);
                                                    //console.log("maxVal2",maxVal2);

                                                    let minVal3 = "N++";
                                                    minVal3 = coSort[coDisplay.indexOf(minVal3)];
                                                    let maxVal3 = coSort[coDisplay.length-1];
                                                    ///console.log("maxVal3",maxVal3);

                                                    if(coVal >= parseInt(minVal) && coVal <= parseInt(maxVal) )
                                                        tingeValue = 'White';
                                                    if(coVal >= parseInt(minVal1)  && coVal <= parseInt(maxVal1) )
                                                        tingeValue = 'Off White';
                                                    if(coVal >= parseInt(minVal2) && coVal <= parseInt(maxVal2) )
                                                        tingeValue = 'Yellow';  
                                                    if(coVal >= parseInt(minVal3) && coVal <= parseInt(maxVal3) )
                                                        tingeValue = 'Yellow';    
                                                    let co =  pktDtl["co"]||'';
                                                    if(co=='FANCY'){
                                                        tingeValue = '';
                                                    }  
                                               }
                                            }              
                                            if(tingeValue == ''){
                                                if(source=='qsol' || source=='qs'){
                                                    attrVal=prpDisplay[prpSort.indexOf(parseInt(attrVal))] || '';
                                                }else{
                                                    attrVal=prpWeb[prpSort.indexOf(parseInt(attrVal))] || '';
                                                }
                                            } else {
                                                attrVal = tingeValue;
                                            }
                                        } else if (data_typ == 'd' && attrVal != '' && attrVal != 0) {
                                            attrVal = getDateyyyymmddToExpected(attrVal, 'dd-mmm-yyyy');
                                        } else if (data_typ == 'n' && attrVal != '' && attrVal != 0) {
                                            let format = dataTypeFormatDtl[attr + "#F"] || 'N';
                                            if (format != 'N') {
                                                if (stock_type != 'NR' && attr == "crtwt") {
                                                    format = 3;
                                                }
                                                attrVal = attrVal || 0;
                                                attrVal = floorFigure(attrVal, format);
                                            }
                                        }
                                        if(data_typ == 'n' && (attrVal=='0' || attrVal==0))
                                               attrVal='';
                                        attrVal = attrVal.trim();
                                        pktDtl[attr] = attrVal;
                                    }
                                    pktDtl["type2A"] = resultRow.type2a || '';
                                    if(rapRte == 1){
                                        attrVal = resultRow.fancyco; 
                                        pktDtl['co'] = attrVal;
                                    }
                                    if (pktIdnWise == "yes") {
                                        searchResultDtl[pkt_idn] = pktDtl;
                                        pktIdnList.push(pkt_idn);
                                    } else {
                                        searchResultList.push(pktDtl);
                                    }

                                }
                                // console.log(searchResultDtl);
                                outJson["pktIdnList"] = pktIdnList;
                                outJson["searchResultDtl"] = searchResultDtl;
                                outJson["searchResultList"] = searchResultList;
                                outJson["status"] = "SUCCESS";
                                outJson["message"] = "SUCCESS";
                            } else {
                                outJson["status"] = "SUCCESS";
                                outJson["message"] = "Sorry No Result Found";
                            }
                            callback(null, outJson);
                        }
                    });


                }
            });


        }
    });

}



exports.getattrStructureDtlWitoutGroup = function (methodParam, tpoolconn, callback) {
    var cachedUrl = require('qaq-core-util').cachedUrl;
    var outJson = {};
    var source = methodParam.source;
    var coIdn = methodParam.coIdn;
    var searchView = methodParam.searchView;
    var attrSortYN = methodParam.attrSortYN || 'N';
    var priYn = methodParam.priYn || 'N';
    let optgroup = methodParam.optgroup || '';
    let prefix = methodParam.prefix || '';
    let plusMinusValueYN = methodParam.plusMinusValueYN || 'Y';

    coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
        if (productAttributeM == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Product Attribute";
            callback(null, outJson);
        } else {
            productAttributeM = JSON.parse(productAttributeM);
            coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                if (productAttributeDtl == null) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to get Product Sub Attribute";
                    callback(null, outJson);
                } else {
                    productAttributeDtl = JSON.parse(productAttributeDtl);
                    let attrList = [];
                    let attrDtl = {};
                    let prpList = [];
                    let prpDtl = {};
                    let searchViewlen = searchView.length;
                    for (let i = 0; i < searchViewlen; i++) {
                        attrDtl = {};
                        prpList = [];
                        let attr = searchView[i];
                        let data_typ = productAttributeM[attr + "#T"] || '';
                        let print = productAttributeM[attr] || '';
                        let attr_idn = productAttributeM[attr+ "#ID"] || '';
                        let display = productAttributeM[attr + "#DS"] || '';
                        let web = productAttributeM[attr + "#W"] || '';
                        attrDtl["attr"] = attr;
                        attrDtl["attr_idn"] = attr_idn;
                        attrDtl["dataType"] = data_typ;
                        attrDtl["print"] = web;
                        if (attrSortYN == 'Y') {
                            let attrSort = productAttributeM[attr + "#S"] || ''
                            attrDtl["sort"] = attrSort;
                        }
                        // if(source!='qsol' && source!='qs'){
                        // attrDtl["print"]=web;
                        // }else{
                        // attrDtl["print"]=display;
                        // }
                        if (data_typ == 'c') {
                            var prpVal = productAttributeDtl[attr + "#V"] || [];
                            var prpDscr = productAttributeDtl[attr + "#D"] || [];
                            var prpDisplay = productAttributeDtl[attr + "#DI"] || [];
                            var prpPrint = productAttributeDtl[attr + "#P"] || [];
                            var prpWeb = productAttributeDtl[attr + "#W"] || [];
                            var prpSort = productAttributeDtl[attr + "#S"] || [];
                            var prpWebYn = productAttributeDtl[attr + "#WYN"] || [];
                            var prpDfYn = productAttributeDtl[attr + "#DYN"] || [];
                            var prpPYn = productAttributeDtl[attr + "#PYN"] || [];
                            let prpAltGrp = productAttributeDtl[attr + "#AG"] || [];
                            let prpOptionGrp = productAttributeDtl[attr + "#OG"] || [];
                            let prpVallen = prpVal.length;

                            for (let j = 0; j < prpVallen; j++) {
                                let pYn = prpPYn[j];
                                if (priYn == 'N')
                                    pYn = 1;
                                if (pYn == 1) {
                                    prpDtl = {};
                                    let val = prpVal[j] || '';
                                    let webyn = prpWebYn[j] || 0;
                                    let dfyn = prpDfYn[j] || 0;
                                    let grp = prpAltGrp[j] || '';
                                    let optGrp = prpOptionGrp[j] || [];

                                    if(optgroup != ''){
                                        if(optGrp.indexOf(optgroup) != -1){
                                            prpDtl["val"] = val;
                                            if (source != 'qsol' && source != 'qs') {
                                                prpDtl["print"] = prpWeb[j] || '';
                                            } else {
                                                prpDtl["print"] = prpPrint[j] || '';
                                            }
                                            prpDtl["sort"] = "" + prpSort[j] + "" || '';
                                            prpList.push(prpDtl);
                                        }
                                    } else {
                                        prpDtl["val"] = val;
                                        let printDtl = "";
                                        if (source != 'qsol' && source != 'qs') {
                                            printDtl = prpWeb[j] || '';
                                        } else {
                                            printDtl = prpPrint[j] || '';
                                        }
                                        prpDtl["print"] = printDtl;
                                        prpDtl["sort"] = "" + prpSort[j] + "" || '';
                                        if(plusMinusValueYN == 'Y'){
                                            prpList.push(prpDtl);
                                        } else {
                                            if(printDtl.indexOf("+") == -1 && printDtl.indexOf("-") == -1)
                                                prpList.push(prpDtl);
                                        }
                                    }  
                                }
                            }
                            attrDtl["prpList"] = prpList;
                        }
                        attrList.push(attrDtl);
                    }
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    outJson["attrStructureDtl"] = attrList
                    callback(null, outJson);
                }
            })
        }
    })
}


exports.getattrStructureDtl = function (methodParam, tpoolconn, callback) {
    var cachedUrl = require('qaq-core-util').cachedUrl;
    var outJson = {};
    var source = methodParam.source;
    var coIdn = methodParam.coIdn;
    var searchView = methodParam.searchView;
    var attrSortYN = methodParam.attrSortYN || 'N';
    let prefix = methodParam.prefix || '';
    coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
        if (productAttributeM == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Product Attribute";
            callback(null, outJson);
        } else {
            productAttributeM = JSON.parse(productAttributeM);
            coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                if (productAttributeDtl == null) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to get Product Sub Attribute";
                    callback(null, outJson);
                } else {
                    productAttributeDtl = JSON.parse(productAttributeDtl);
                    let attrList = [];
                    let attrDtl = {};
                    let prpList = [];
                    let prpDtl = {};
                    let searchViewlen = searchView.length;
                    for (let i = 0; i < searchViewlen; i++) {
                        attrDtl = {};
                        prpList = [];
                        let attr = searchView[i];
                        let data_typ = productAttributeM[attr + "#T"] || '';
                        let print = productAttributeM[attr] || ''
                        let display = productAttributeM[attr + "#DS"] || ''
                        let web = productAttributeM[attr + "#W"] || ''
                        attrDtl["attr"] = attr;
                        attrDtl["dataType"] = data_typ;
                        attrDtl["print"] = web;
                        if (attrSortYN == 'Y') {
                            let attrSort = productAttributeM[attr + "#S"] || ''
                            attrDtl["sort"] = attrSort;
                        }
                        // if(source!='qsol' && source!='qs'){
                        // attrDtl["print"]=web;
                        // }else{
                        // attrDtl["print"]=display;
                        // }
                        if (data_typ == 'c') {
                            var prpVal = productAttributeDtl[attr + "#V"] || [];
                            var prpDscr = productAttributeDtl[attr + "#D"] || [];
                            var prpDisplay = productAttributeDtl[attr + "#DI"] || [];
                            var prpPrint = productAttributeDtl[attr + "#P"] || [];
                            var prpWeb = productAttributeDtl[attr + "#W"] || [];
                            var prpSort = productAttributeDtl[attr + "#S"] || [];
                            var prpWebYn = productAttributeDtl[attr + "#WYN"] || [];
                            var prpDfYn = productAttributeDtl[attr + "#DYN"] || [];
                            let prpAltGrp = productAttributeDtl[attr + "#AG"] || [];
                            let prpVallen = prpVal.length;
                            let finalPrpSort = [];
                            let alreadyDoneGroup = [];
                            if (source == 'website' || source == 'ios' || source == 'android' || source == 'api' || source == 'qs')
                                finalPrpSort = modDataOfPrp(prpSort, prpAltGrp);
                            for (let j = 0; j < prpVallen; j++) {
                                prpDtl = {};
                                let val = prpVal[j] || '';
                                let webyn = prpWebYn[j] || 0;
                                let dfyn = prpDfYn[j] || 0;
                                let grp = prpAltGrp[j] || '';

                                prpDtl["val"] = val;
                                if (source != 'qsol' && source != 'qs') {
                                    prpDtl["print"] = prpWeb[j] || '';
                                } else {
                                    prpDtl["print"] = prpPrint[j] || '';
                                }
                                prpDtl["sort"] = "" + prpSort[j] + "" || '';
                                if ((webyn == 1 && (source == 'website' || source == 'ios' || source == 'android' || source == 'api')) || (webyn == 1 && (source == 'qs'))) {
                                    if (alreadyDoneGroup.indexOf(grp) <= -1 && grp != '') {
                                        prpDtl["sort"] = "" + finalPrpSort[j] + "" || '';
                                        prpDtl["print"] = grp;
                                        prpDtl["val"] = grp;
                                        prpList.push(prpDtl);
                                        alreadyDoneGroup.push(grp);
                                    } else if (grp == '') {
                                        prpList.push(prpDtl);
                                    }
                                } else if (source == 'qsol')
                                    prpList.push(prpDtl);
                            }
                            attrDtl["prpList"] = prpList;
                        }
                        attrList.push(attrDtl);
                    }
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    outJson["attrStructureDtl"] = attrList
                    callback(null, outJson);
                }
            })
        }
    })
}

function modDataOfPrp(prpSort, prpAltGrp) {
    let localprpSort = [];
    for (let z = 0; z < prpSort.length; z++) {
        localprpSort.push(prpSort[z]);
    }
    let prpAltGrplen = prpAltGrp.length;
    let map = {};
    for (let z = 0; z < prpAltGrplen; z++) {
        let outergrp = prpAltGrp[z] || '';
        if (outergrp != '') {
            let srt = '';
            for (let l = 0; l < prpAltGrplen; l++) {
                let innergrp = prpAltGrp[l];
                if (innergrp != '') {
                    if (outergrp == innergrp) {
                        if (srt == '')
                            srt = prpSort[l];
                        else
                            srt += '@' + prpSort[l];
                    }
                }
                localprpSort.splice(z, 1);
                localprpSort.splice(z, 0, srt);
            }
        }
    }
    return localprpSort;
}

exports.getattrStructureDtlGroupWise = function (methodParam, tpoolconn, callback) {
    let source = methodParam.source;
    let applIdn = methodParam.applIdn;
    let coIdn = methodParam.coIdn;
    let searchView = methodParam.searchView;
    let searchViewdisplay_group = methodParam.searchViewdisplay_group || [];
    let searchViewdisplay_row = methodParam.searchViewdisplay_row || [];
    let reqPrpListYn = methodParam.reqPrpListYn || 'y';
    let dnaYn = methodParam.dna || 'n';
    let optgroup = methodParam.optgroup || '';
    let prefix = methodParam.prefix || '';
    let cachedUrl = require('qaq-core-util').cachedUrl;
    let outJson = {};
    coreUtil.getCache(prefix+"attributeMasterDtl_" + coIdn, cachedUrl).then(attributeMasterDtl => {
        if (attributeMasterDtl == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Application AttributeDtl";
            callback(null, outJson);
        } else {
            attributeMasterDtl = JSON.parse(attributeMasterDtl);
            // console.log(attributeMasterDtl);
            coreUtil.getCache(prefix+"attributeMaster", cachedUrl).then(attributeMaster => {
                if (attributeMaster == null) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to get Application Attribute";
                    callback(null, outJson);
                } else {
                    attributeMaster = JSON.parse(attributeMaster);
                    coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
                        if (productAttributeM == null) {
                            outJson["status"] = "FAIL";
                            outJson["message"] = "Fail to get Product Attribute";
                            callback(null, outJson);
                        } else {
                            productAttributeM = JSON.parse(productAttributeM);
                            coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                                if (productAttributeDtl == null) {
                                    outJson["status"] = "FAIL";
                                    outJson["message"] = "Fail to get Product Sub Attribute";
                                    callback(null, outJson);
                                } else {
                                    productAttributeDtl = JSON.parse(productAttributeDtl);
                                    let attrDtl = {};
                                    let prpList = [];
                                    let prpDtl = {};
                                    let searchViewlen = searchView.length;
                                    let groupDtl = {};
                                    let searchViewdisplay_grouplen = searchViewdisplay_group.length;
                                    let searchViewdisplay_rowlen = searchViewdisplay_row.length;

                                    let displayRowattr = "display_row";
                                    let prpValdisplayRow = attributeMasterDtl[displayRowattr + "#V"] || [];
                                    let prpDIdndisplayRow = attributeMasterDtl[displayRowattr + "#I"] || [];
                                    let count = 0;
                                    for (let i = 0; i < searchViewlen; i++) {
                                        attrDtl = {};
                                        prpList = [];
                                        count++;
                                        let attr = searchView[i];
                                        let display_group = searchViewdisplay_group[i];
                                        let attrList = groupDtl[display_group] || [];
                                        let data_typ = productAttributeM[attr + "#T"] || '';
                                        let print = productAttributeM[attr] || ''
                                        let display = productAttributeM[attr + "#DS"] || ''
                                        let web = productAttributeM[attr + "#W"] || ''
                                        attrDtl["attr"] = attr;
                                        attrDtl["rnk"] = count;
                                        attrDtl["dataType"] = data_typ;
                                        // attrDtl["class"]=searchViewdisplay_row[i];
                                        if (searchViewdisplay_rowlen > 0)
                                            attrDtl["displayType"] = prpValdisplayRow[prpDIdndisplayRow.indexOf(searchViewdisplay_row[i])];
                                        else
                                            attrDtl["displayType"] = prpValdisplayRow[prpDIdndisplayRow.indexOf(913)];
                                        if (dnaYn == 'y')
                                            attrDtl["print"] = display;
                                        else
                                            attrDtl["print"] = web;
                                        // if(source!='qsol' && source!='qs'){
                                        // attrDtl["print"]=web;
                                        // }else{
                                        // attrDtl["print"]=display;
                                        // }
                                        if (data_typ == 'c' && reqPrpListYn == 'y') {
                                            let prpVal = productAttributeDtl[attr + "#V"] || [];
                                            let prpDscr = productAttributeDtl[attr + "#D"] || [];
                                            let prpDisplay = productAttributeDtl[attr + "#DI"] || [];
                                            let prpPrint = productAttributeDtl[attr + "#P"] || [];
                                            let prpWeb = productAttributeDtl[attr + "#W"] || [];
                                            let prpSort = productAttributeDtl[attr + "#S"] || [];
                                            let prpWebYn = productAttributeDtl[attr + "#WYN"] || [];
                                            let prpDfYn = productAttributeDtl[attr + "#DYN"] || [];
                                            let prpAltGrp = productAttributeDtl[attr + "#AG"] || [];
                                            let prpOptionGrp = productAttributeDtl[attr + "#OG"] || [];
                                            let prpVallen = prpVal.length;
                                            let finalPrpSort = [];
                                            let alreadyDoneGroup = [];
                                            if (source == 'website' || source == 'ios' || source == 'android' || source == 'api' || source == 'qs')
                                                finalPrpSort = modDataOfPrp(prpSort, prpAltGrp);
                                            // console.log(prpDfYn);
                                            // if(attr=='co'){
                                            // console.log(finalPrpSort);
                                            // }
                                            for (let j = 0; j < prpVallen; j++) {
                                                prpDtl = {};
                                                let val = prpVal[j] || '';
                                                let webyn = prpWebYn[j] || 0;
                                                let dfyn = prpDfYn[j] || 0;
                                                let grp = prpAltGrp[j] || '';
                                                let optGrp = prpOptionGrp[j] || [];

                                                if(optgroup != ''){
                                                    if(optGrp.indexOf(optgroup) != -1){
                                                        prpDtl["val"] = val;
                                                        if (source != 'qsol' && source != 'qs') {
                                                            prpDtl["print"] = prpWeb[j] || '';
                                                        } else {
                                                            prpDtl["print"] = prpPrint[j] || '';
                                                        }
                                                        prpDtl["sort"] = "" + prpSort[j] + "" || '';
                                                        prpList.push(prpDtl);
                                                    }
                                                } else {
                                                    prpDtl["val"] = val;
                                                    if (source != 'qsol' && source != 'qs') {
                                                        prpDtl["print"] = prpWeb[j] || '';
                                                    } else {
                                                        prpDtl["print"] = prpPrint[j] || '';
                                                    }
                                                    prpDtl["sort"] = "" + prpSort[j] + "" || '';
                                                    if ((webyn == 1 && (source == 'website' || source == 'ios' || source == 'android' || source == 'api')) || (dfyn == 1 && (source == 'qs'))) {
                                                        if (alreadyDoneGroup.indexOf(grp) <= -1 && grp != '') {
                                                            prpDtl["sort"] = "" + finalPrpSort[j] + "" || '';
                                                            prpDtl["print"] = grp;
                                                            prpDtl["val"] = grp;
                                                            prpList.push(prpDtl);
                                                            alreadyDoneGroup.push(grp);
                                                        } else if (grp == '') {
                                                            prpList.push(prpDtl);
                                                        }
                                                    } else if (source == 'qsol')
                                                        prpList.push(prpDtl);
                                                }
                                            }
                                            attrDtl["prpList"] = prpList;
                                        }
                                        attrList.push(attrDtl);
                                        groupDtl[display_group] = attrList;
                                    }
                                    // console.log(groupDtl);
                                    let displayattr = "display_group";

                                    let prpValdisplay = attributeMasterDtl[displayattr + "#V"] || [];
                                    let prpDisplaydisplay = attributeMasterDtl[displayattr + "#DI"] || [];
                                    let prpWebdisplay = attributeMasterDtl[displayattr + "#W"] || [];
                                    let prpDIdndisplay = attributeMasterDtl[displayattr + "#I"] || [];
                                    // console.log(prpWebdisplay);
                                    // console.log(prpWebdisplay[0]);
                                    let prpDIdndisplaylen = prpDIdndisplay.length;
                                    let attrStructureList = [];
                                    let attrStructureDtl = {};
                                    for (let z = 0; z < prpDIdndisplaylen; z++) {
                                        attrStructureDtl = {};
                                        let attrDIdnVal = prpDIdndisplay[z];
                                        let attrList = groupDtl[attrDIdnVal] || [];
                                        // console.log(attrList);
                                        let attrListlen = attrList.length;
                                        if (attrListlen > 0) {
                                            if (source != 'qsol' && source != 'qs') {
                                                attrStructureDtl["grp"] = prpWebdisplay[z] || '';
                                            } else {
                                                attrStructureDtl["grp"] = prpDisplaydisplay[z] || '';
                                            }
                                            attrStructureDtl["component"] = attrList;
                                            attrStructureList.push(attrStructureDtl);
                                        }
                                    }
                                    outJson["status"] = "SUCCESS";
                                    outJson["message"] = "SUCCESS";
                                    outJson["attrStructureDtl"] = attrStructureList;
                                    callback(null, outJson);
                                }
                            })
                        }
                    })
                }
            });
        }
    });
}



exports.imageDtl = function (methodParam, tpoolconn, callback) {
    let source = methodParam.source || '';
    let coIdn = methodParam.coIdn || '';
    let outJson = {};
    let imageDtl = {};
    let imagePrpList = [];
    let params = [coIdn];
    let fmt = {};
    let query = "select a.attr_idn,a.attr,a.display,a.print,a.web,a.srt,b.val\n" +
        "from\n" +
        "appl_attr_m a,client_info b\n" +
        "where \n" +
        "a.attr_idn=b.attr_idn and a.mdl='image' and a.stt=1 and b.stt=1 and b.co_idn=$1 ";

    if(source == 'api'){
        query +=" and a.attr not in ('helium_report','rough_packing_list','rough_kp_cert','rough_invoice','rough_seal_bag','rjc_link') ";
    }

    query +=" order by a.srt ";
    //console.log(query);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
        if (error) {
            outJson["result"] = '';
            outJson["status"] = "FAIL";
            outJson["message"] = "Get imageDtl Execute Query!" + error.message;
            callback(null, outJson);
        } else {
            let rowCount = result.rowCount;
            if (rowCount > 0) {
                for (let k = 0; k < rowCount; k++) {
                    let resultRow = result.rows[k];
                    let attr = resultRow.attr;
                    if (source == 'qsol' || source == 'qs') {
                        imageDtl[attr + "#D"] = resultRow.display;
                    } else {
                        imageDtl[attr + "#D"] = resultRow.web;
                    }
                    imageDtl[attr] = resultRow.val;
                    imagePrpList.push(attr);
                }
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "Image Not Available";
                callback(null, outJson);
            }
            outJson["imageDtl"] = imageDtl;
            outJson["imagePrpList"] = imagePrpList;
            callback(null, outJson);
        }
    });
}

exports.summaryTrns = function (methodParam, tpoolconn, callback) {
    let transaction_sales_idn = methodParam.transaction_sales_idn || '';
    let dstatus = methodParam.dstatus;
    let coIdn = methodParam.coIdn;
    let co_serial = methodParam.co_serial || '';
    let fmt = {};
    let params = [];
    let outJson = {};
    let summaryTrnsDtl = {};
    let conQ = "";
    if(transaction_sales_idn == '' && co_serial == '')
        transaction_sales_idn = '0';

    if (dstatus == 'ISCF')
        conQ += "  and CASE WHEN a.grp = 'promotions' then b.status=b.status else  b.status in ('CF','IS') end ";
    else if (dstatus != 'ALL')
        conQ += "  and CASE WHEN a.grp = 'promotions' then b.status=b.status else  b.status = '" + dstatus + "' end ";

    var sql = "with summary_v as(\n" +
        "select a.transaction_attr, a.transaction_sales_idn,a.process_idn,c.grp,a.co_serial,a.transaction_code,get_terms_desc(b.buyer_terms_idn) termsdsc ,b.nme_idn buyerIdn,\n" +
        "get_nme(b.nme_idn) buyer,get_nme(a.emp_idn) employee,c.print process_nme, \n" +
        "to_char(a.trns_ts + interval '5.5 hours','dd-MON-yyyy') memodate \n" +
        "from\n" +
        "transaction_sales a,buyer_terms b,stock_process c \n" +
        "where\n" +
        "a.buyer_terms_idn=b.buyer_terms_idn and a.process_idn=c.process_idn\n" +
        " and c.stt = 1 and c.co_idn= $1 and a.co_idn=c.co_idn \n";
        let cnt = 1;
        params.push(coIdn);
        if(transaction_sales_idn != ''){
            cnt++;
            sql += " and a.transaction_sales_idn=$"+cnt+" \n";
            params.push(transaction_sales_idn);
        }
        if(co_serial != ''){
            cnt++;
            sql += " and a.co_serial=$"+cnt+" \n";
            params.push(co_serial);
        }
        sql += " ) ";
        cnt++;
        sql +="select  a.transaction_attr,a.process_nme,a.transaction_sales_idn,a.process_idn,a.grp, a.co_serial,a.transaction_code,a.buyerIdn,a.buyer,a.employee,a.termsdsc\n" +
        ",sum(b.qty) qty,trunc(sum(b.weight + CAST(COALESCE(NULLIF(b.issval ->> 'wt_diff', ''), '0') AS numeric)),2) weight,trunc(sum(b.weight + CAST(COALESCE(NULLIF(b.issval ->> 'wt_diff', ''), '0') AS numeric)),2) total_weight,trunc(sum(coalesce( b.sal_rte,b.quot)*trunc(b.weight + CAST(COALESCE(NULLIF(b.issval ->> 'wt_diff', ''), '0') AS numeric),2)),2) quot_amount,trunc(sum(coalesce(b.sal_rte, b.quot)*trunc(b.weight + CAST(COALESCE(NULLIF(b.issval ->> 'wt_diff', ''), '0') AS numeric),2)),2) sal_amount, \n" +
        "  trunc((sum((COALESCE(b.sal_rte,b.quot)*trunc(b.weight + CAST(COALESCE(NULLIF(b.issval ->> 'wt_diff', ''), '0') AS numeric),2))/ coalesce(b.sal_exh_rte,b.quot_exh_rte) )* 100)/sum(cast(sm.attr ->> 'rap_rte' as numeric)*b.weight)-100,2) sal_dis, " +
        " trunc(sum(COALESCE(b.sal_rte,b.quot)*trunc(b.weight + CAST(COALESCE(NULLIF(b.issval ->> 'wt_diff', ''), '0') AS numeric),2))/sum(trunc(b.weight + CAST(COALESCE(NULLIF(b.issval ->> 'wt_diff', ''), '0') AS numeric),2)),2)  quot, a.memodate \n" +
        "from \n" +
        "summary_v a,transaction_d_sales b,stock_m sm \n" +
        "where\n" +
        "a.transaction_sales_idn=b.transaction_sales_idn \n" + conQ +
        //"b.status=$2\n" + 
        "and b.stock_idn = sm.stock_idn and sm.co_idn= $"+cnt+" and sm.stt = 1 \n" +
        "group by  a.transaction_attr, a.process_nme,a.transaction_sales_idn,a.process_idn,a.co_serial,a.transaction_code,a.buyer,a.buyerIdn,a.employee,a.termsdsc, a.grp,a.memodate \n";
   
        params.push(coIdn);
    //params.push(dstatus);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In summaryTrns Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                let sal_amount = parseFloat(result.rows[0].sal_amount);
                let transaction_attr = result.rows[0].transaction_attr || {};
                let charges = transaction_attr.charges || [];
                if (charges.length > 0) {
                    charges.forEach(element => {
                        if (element.applyby == 'MNL' && element.value != '') {
                            chargeVal = parseFloat(element.value);
                            sal_amount = sal_amount + (chargeVal);
                        }

                    });
                }
                summaryTrnsDtl["transaction_sales_idn"] = result.rows[0].transaction_sales_idn;
                summaryTrnsDtl["process_idn"] = result.rows[0].process_idn;
                summaryTrnsDtl["processgroup"] = result.rows[0].grp;
                summaryTrnsDtl["co_serial"] = result.rows[0].co_serial;
                summaryTrnsDtl["transaction_code"] = result.rows[0].transaction_code;
                summaryTrnsDtl["buyer"] = result.rows[0].buyer;
                summaryTrnsDtl["employee"] = result.rows[0].employee;
                summaryTrnsDtl["terms"] = result.rows[0].termsdsc;
                summaryTrnsDtl["buyerIdn"] = result.rows[0].buyeridn;
                summaryTrnsDtl["qty"] = result.rows[0].qty;
                summaryTrnsDtl["weight"] = result.rows[0].total_weight;
                //summaryTrnsDtl["totalweight"] = result.rows[0].weight;
                summaryTrnsDtl["quot_amount"] = result.rows[0].quot_amount;
                summaryTrnsDtl["sal_amount"] = floorFigure(sal_amount, 2);
                summaryTrnsDtl["sal_dis"] = result.rows[0].sal_dis;
                summaryTrnsDtl["process_nme"] = result.rows[0].process_nme;
                summaryTrnsDtl["memodate"] = result.rows[0].memodate;
                summaryTrnsDtl["quot"] = result.rows[0].quot;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            outJson["summaryTrnsDtl"] = summaryTrnsDtl;
            callback(null, outJson);
        }
    });
}

exports.summaryTransactionWeb = function (methodParam, tpoolconn, callback) {
    let transaction_web_idn = methodParam.transaction_web_idn || '';
    let co_serial = methodParam.co_serial || '';
    let dstatus = methodParam.dstatus;
    let coIdn = methodParam.coIdn;
    let fmt = {};
    let params = [];
    let outJson = {};
    let summaryTrnsDtl = {};
    let conQ = "";

    if (dstatus == 'ISCF')
        conQ += "  and CASE WHEN a.grp = 'promotions' then b.status=b.status else  b.status in ('CF','IS') end ";
    else if (dstatus != 'ALL')
        conQ += "  and CASE WHEN a.grp = 'promotions' then b.status=b.status else  b.status = '" + dstatus + "' end ";

    var sql = "with summary_v as(\n" +
        "select a.transaction_attr, a.transaction_web_idn,a.process_idn,c.grp,a.co_serial,a.transaction_code,get_terms_desc(b.buyer_terms_idn) termsdsc ,b.nme_idn buyerIdn,\n" +
        "get_nme(b.nme_idn) buyer,get_nme(a.emp_idn) employee,c.print process_nme, \n" +
        "to_char(a.trns_ts + interval '5.5 hours','dd-MON-yyyy') memodate \n" +
        "from\n" +
        "transaction_web a,buyer_terms b,stock_process c \n" +
        "where\n" +
        "a.buyer_terms_idn=b.buyer_terms_idn and a.process_idn=c.process_idn\n" +
        "and c.stt=1 and c.co_idn =  $1 and a.co_idn=c.co_idn \n";
        let cnt = 1;
        params.push(coIdn);
        if(transaction_web_idn != ''){
            cnt++;
            sql += " and a.transaction_web_idn=$"+cnt+" \n";
            params.push(transaction_web_idn);
        }
        if(co_serial != ''){
            cnt++;
            sql += " and a.co_serial=$"+cnt+" \n";
            params.push(co_serial);
        }
        sql += " ) ";
        cnt++;
        sql +="select  a.transaction_attr,a.process_nme,a.transaction_web_idn,a.process_idn,a.grp, a.co_serial,a.transaction_code,a.buyerIdn,a.buyer,a.employee,a.termsdsc\n" +
        ",sum(b.qty) qty,trunc(sum(b.weight),2) weight,trunc(sum(coalesce( b.sal_rte,b.quot)*b.weight),2) quot_amount,trunc(sum(coalesce(b.sal_rte, b.quot)*b.weight),2) sal_amount, \n" +
        "  trunc((sum((COALESCE(b.sal_rte,b.quot)*b.weight)/ coalesce(b.sal_exh_rte,b.quot_exh_rte) )* 100)/sum(cast(sm.attr ->> 'rap_rte' as numeric)*b.weight)-100,2) sal_dis, " +
        " trunc(sum(COALESCE(b.sal_rte,b.quot)*b.weight)/sum(b.weight),2)  quot, a.memodate \n" +
        "from \n" +
        "summary_v a,transaction_d_web b,stock_m sm \n" +
        "where\n" +
        "a.transaction_web_idn=b.transaction_web_idn \n" + conQ +
        //"b.status=$2\n" + 
        "and b.stock_idn = sm.stock_idn and sm.co_idn = $"+cnt+" and sm.stt=1 \n" +
        "group by  a.transaction_attr, a.process_nme,a.transaction_web_idn,a.process_idn,a.co_serial,a.transaction_code,a.buyer,a.buyerIdn,a.employee,a.termsdsc, a.grp,a.memodate \n";
    params.push(coIdn);
    //params.push(dstatus);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In summaryTrns Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                let sal_amount = parseFloat(result.rows[0].sal_amount);
                let transaction_attr = result.rows[0].transaction_attr || {};
                let charges = transaction_attr.charges || [];
                if (charges.length > 0) {
                    charges.forEach(element => {
                        if (element.applyby == 'MNL' && element.value != '') {
                            chargeVal = parseFloat(element.value);
                            sal_amount = sal_amount + (chargeVal);
                        }

                    });
                }
                summaryTrnsDtl["transaction_sales_idn"] = result.rows[0].transaction_web_idn;
                summaryTrnsDtl["process_idn"] = result.rows[0].process_idn;
                summaryTrnsDtl["processgroup"] = result.rows[0].grp;
                summaryTrnsDtl["co_serial"] = result.rows[0].co_serial;
                summaryTrnsDtl["transaction_code"] = result.rows[0].transaction_code;
                summaryTrnsDtl["buyer"] = result.rows[0].buyer;
                summaryTrnsDtl["employee"] = result.rows[0].employee;
                summaryTrnsDtl["terms"] = result.rows[0].termsdsc;
                summaryTrnsDtl["buyerIdn"] = result.rows[0].buyeridn;
                summaryTrnsDtl["qty"] = result.rows[0].qty;
                summaryTrnsDtl["weight"] = result.rows[0].weight;
                summaryTrnsDtl["quot_amount"] = result.rows[0].quot_amount;
                summaryTrnsDtl["sal_amount"] = floorFigure(sal_amount, 2);
                summaryTrnsDtl["sal_dis"] = result.rows[0].sal_dis;
                summaryTrnsDtl["process_nme"] = result.rows[0].process_nme;
                summaryTrnsDtl["memodate"] = result.rows[0].memodate;
                summaryTrnsDtl["quot"] = result.rows[0].quot;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            outJson["summaryTrnsDtl"] = summaryTrnsDtl;
            callback(null, outJson);
        }
    });
}

exports.summaryTrnsWeb = function (methodParam, tpoolconn, callback) {
    let transaction_web_idn = methodParam.transaction_web_idn;
    let dstatus = methodParam.dstatus;
    let coIdn = methodParam.coIdn;
    let fmt = {};
    let params = [];
    let outJson = {};
    let summaryTrnsDtl = {};
    var sql = "with summary_v as(\n" +
        "select a.transaction_web_idn,a.process_idn,a.co_serial,a.transaction_code,\n" +
        "get_nme(b.nme_idn) buyer,get_nme(a.emp_idn) employee,c.print process_nme\n" +
        "from\n" +
        "transaction_web a,buyer_terms b,stock_process c \n" +
        "where\n" +
        "a.buyer_terms_idn=b.buyer_terms_idn and a.process_idn=c.process_idn\n" +
        "and a.transaction_web_idn=$1 and c.co_idn=$3 and c.stt = 1 and a.co_idn=c.co_idn )\n" +
        "select a.process_nme,a.transaction_web_idn,a.process_idn,a.co_serial,a.transaction_code,a.buyer,a.employee\n" +
        ",sum(b.qty) qty,trunc(sum(b.weight),2) weight,trunc(sum(b.quot_amount),2) quot_amount,trunc(sum(COALESCE(b.sal_amount,b.quot_amount)),2) sal_amount\n" +
        "from \n" +
        "summary_v a,transaction_d_web b\n" +
        "where\n" +
        "a.transaction_web_idn=b.transaction_web_idn and\n" +
        "b.status=$2\n" +
        "group by a.process_nme,a.transaction_web_idn,a.process_idn,a.co_serial,a.transaction_code,a.buyer,a.employee\n";
    params.push(transaction_web_idn);
    params.push(dstatus);
    params.push(coIdn);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In summaryTrns Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                summaryTrnsDtl["transaction_web_idn"] = result.rows[0].transaction_web_idn;
                summaryTrnsDtl["process_idn"] = result.rows[0].process_idn;
                summaryTrnsDtl["co_serial"] = result.rows[0].co_serial;
                summaryTrnsDtl["transaction_code"] = result.rows[0].transaction_code;
                summaryTrnsDtl["buyer"] = result.rows[0].buyer;
                summaryTrnsDtl["employee"] = result.rows[0].employee;
                summaryTrnsDtl["qty"] = result.rows[0].qty;
                summaryTrnsDtl["weight"] = result.rows[0].weight;
                summaryTrnsDtl["quot_amount"] = result.rows[0].quot_amount;
                summaryTrnsDtl["sal_amount"] = result.rows[0].sal_amount;
                summaryTrnsDtl["process_nme"] = result.rows[0].process_nme;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            outJson["summaryTrnsDtl"] = summaryTrnsDtl;
            callback(null, outJson);
        }
    });
}

exports.getStatusList = function (searchGroup, coIdn, tpoolconn, statusGrp, stock_group,prefix, callback) {
    let fmt = {};
    let params = [];
    let outJson = {};
    let kv = [];
    let directstatusList = [];
    let map = {};
    map["k"] = "";
    map["v"] = "Select Status";
    map["d"] = "";
    kv.push(map);

    //console.log(statusGrp);

    var sql = "select status,print,description ";

    if (statusGrp != '')
        sql += ", " + statusGrp;

    sql += " from stock_status where stt=1 and co_idn=$1 and $2=any(search_group) ";

    if (stock_group != '' && stock_group.length > 0)
        sql += " and  stock_group = ANY(ARRAY['" + stock_group.join("','") + "'])";

    if (statusGrp != '')
        sql += " order by " + statusGrp + " ,print";
    else
        sql += " order by print";


    params.push(coIdn);
    params.push(searchGroup);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getEmployeeList Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                let preBiGrp = '';
                let statuslist = '';
                if (statusGrp != '') {
                    let cachedUrl = require('qaq-core-util').cachedUrl;
                    coreUtil.getCache(prefix+"attributeMasterDtl_" + coIdn, cachedUrl).then(attributeMasterDtl => {
                        if (attributeMasterDtl == null) {
                            outJson["status"] = "FAIL";
                            outJson["message"] = "Fail to get Application AttributeDtl";
                            callback(null, outJson);
                        } else {
                            attributeMasterDtl = JSON.parse(attributeMasterDtl);
                            //console.log(attributeMasterDtl)
                            let displayRowattr = statusGrp;
                            let prpValdisplayRow = attributeMasterDtl[displayRowattr + "#V"] || [];
                            let prpDidisplayRow = attributeMasterDtl[displayRowattr + "#DI"] || [];
                            let prpDdisplayRow = attributeMasterDtl[displayRowattr + "#D"] || [];
                            let prpSortdisplayRow = attributeMasterDtl[displayRowattr + "#S"] || [];
                            for (var i = 0; i < len; i++) {
                                var resultRows = result.rows[i] || "";
                                var biGrp = resultRows[statusGrp];
                                if (preBiGrp == '')
                                    preBiGrp = biGrp;

                                if (preBiGrp != biGrp) {
                                    map = {};
                                    map["label"] = prpDidisplayRow[prpValdisplayRow.indexOf(preBiGrp)] || 'NA';
                                    map["srt"] = prpSortdisplayRow[prpValdisplayRow.indexOf(preBiGrp)] || 1000;
                                    map["key"] = preBiGrp || 'NA';
                                    map["stt"] = statuslist;
                                    map["k"]=prpDdisplayRow[prpValdisplayRow.indexOf(preBiGrp)] || 'NA';
                                    map["v"]=statuslist;
                                    kv.push(map);
                                    statuslist = '';
                                    preBiGrp = biGrp;
                                }
                                var stt = result.rows[i].status || "";
                                directstatusList.push(result.rows[i].status);
                                if (statuslist == '')
                                    statuslist += stt;
                                else
                                    statuslist += "," + stt;
                            }
                            map = {};
                            map["label"] = prpDidisplayRow[prpValdisplayRow.indexOf(preBiGrp)] || 'NA';
                            map["srt"] = prpSortdisplayRow[prpValdisplayRow.indexOf(preBiGrp)] || 1000;
                            map["key"] = preBiGrp || 'NA';
                            map["stt"] = statuslist;
                            map["k"]=prpDdisplayRow[prpValdisplayRow.indexOf(preBiGrp)] || 'NA';
                            map["v"]=statuslist;
                            kv.push(map);

                            kv.sort((val1, val2) => {
                                return (val1.srt) - (val2.srt);
                            });
                            outJson["status"] = "SUCCESS";
                            outJson["message"] = "SUCCESS";
                            outJson["statusList"] = kv;
                            outJson["directstatusList"] = directstatusList;
                            callback(null, outJson);
                        }
                    })
                } else {
                    for (var i = 0; i < len; i++) {
                        map = {};
                        map["k"] = result.rows[i].status || "";
                        map["v"] = result.rows[i].print || "";
                        map["d"] = result.rows[i].description || "";
                        kv.push(map);
                        directstatusList.push(result.rows[i].status);
                    }
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    outJson["statusList"] = kv;
                    outJson["directstatusList"] = directstatusList;
                    callback(null, outJson);
                }
               
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                outJson["statusList"] = kv;
                outJson["directstatusList"] = directstatusList;
                callback(null, outJson);
            }
        }
    })
}

exports.getBiGrpStatusList = function (methodParam, tpoolconn, callback) {
    let source = methodParam.source;
    let coIdn = methodParam.coIdn;
    let bi_group_list = methodParam.bi_group_list || [];
    let fmt = {};
    let params = [];
    let outJson = {};
    let kv = [];
    let directstatusList = [];
    let map = {};
    map["k"] = "";
    map["v"] = "Select Status";
    map["d"] = "";
    kv.push(map);

    var sql = "select status,print,description from stock_status "+
        " where stt=1 and co_idn=$1 and $2=any(search_group) "+
        " and  bi_group in ('"+bi_group_list.join("','")+"') "+
        " order by print";


    params.push(coIdn);
    params.push(source);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getBiGrpStatusList Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                for (var i = 0; i < len; i++) {
                    map = {};
                    map["k"] = result.rows[i].status || "";
                    map["v"] = result.rows[i].print || "";
                    map["d"] = result.rows[i].description || "";
                    kv.push(map);
                    directstatusList.push(result.rows[i].status);
                }
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                outJson["statusList"] = kv;
                outJson["directstatusList"] = directstatusList;
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Sorry no result found";
                outJson["statusList"] = kv;
                outJson["directstatusList"] = directstatusList;
            }
        }
    })
}

exports.postTransactionSales = function (methodParam, tpoolconn, callback) {
    var transaction_sales_idn = methodParam.transaction_sales_idn;
    let fmt = {};
    let params = [];
    let outJson = {};
    var sql = "select post_transaction_sales($1)";
    params.push(transaction_sales_idn);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In postTransactionSales Method!" + error.message;
            console.log(outJson);
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            //console.log(result);
            if (len > 0) {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            callback(null, outJson);
        }
    });
}


exports.ExcelFormatList = function (methodParam, connection, callback) {
    var formNme = methodParam.formNme;
    var coIdn = methodParam.coIdn;
    var userIdn = methodParam.userIdn;
    var excelformat = [];
    let outJson = {};
    let excelFmt = "select b.nme,c.display_attr_idn from module_page a ,page_display b , page_display_attr c "+
            "where a.page_idn=b.page_idn and a.stt=1 and b.stt=1 "+
            "and a.form_nme=$1  and b.display_key=$2 "+
            "and b.display_idn=c.display_idn and c.co_idn=$3 and c.stt=1 and coalesce(c.user_idn, $4) = $4 "+
            "and case  "+
            "when (pub_acl = 1) then 1 "+
            "when (pub_acl = 0 and $5 = any(user_acl)) then 1 else 0  "+
            "end = 1  ";
    let params = [];
    params.push(formNme);
    params.push("excel");
    params.push(coIdn);
    params.push(userIdn);
    params.push(userIdn);

    coreDB.executeTransSql(connection, excelFmt, params, {}, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In page_display Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            //console.log(len);
            if (len > 0) {
                for (let i = 0; i < len; i++) {
                    let data = result.rows[i];
                    let nme = data.nme;
                    let display_idn = data.display_attr_idn;
                    let fmt = {};
                    fmt["key"] = display_idn;
                    fmt["val"] = nme;
                    excelformat.push(fmt);
                }

            }

            outJson["result"] = excelformat;
            outJson["status"] = "SUCCESS";
            outJson["message"] = "SUCCESS";
            callback(null, outJson);

        }

    });


}


function getDependAttrList(formula) {
    formula = replaceall("(", "", formula);
    formula = replaceall(")", "", formula);
    formula = replaceall("-", "", formula);
    formula = replaceall("+", "", formula);
    formula = replaceall("/", "", formula);
    formula = replaceall("*", "", formula);
    formula = replaceall("100", "", formula);
    formula = replaceall(" ", "", formula);
    var hashSplit = formula.split("#");
    return splice(hashSplit, [""]);
}

function splice(arrA, arrB) {
    for (let j = 0; j < arrB.length; j++) {
        var i = arrA.indexOf(arrB[j]);
        if (i != -1) {
            arrA.splice(i, 1);
        }
    }
    return arrA;
}



function floorFigure(figure, decimals) {
    let a;
    if(figure!=null && figure!=undefined ){
    if (decimals == -1)
        return Math.floor(figure);
    if (decimals == 0)
        return Math.trunc(figure);
    if (!decimals) decimals = 2;
    let d = Math.pow(10, decimals);

    var str = figure.toString(); 
    a= parseFloat(str); 
    decimals = parseInt(decimals);
    if(str.indexOf(".") != -1){
        var fctr ;

        if (((figure.toString().split(".")[1]).length) == 2) {
            fctr = figure.toString().split(".")[1];
        }        
        if (((figure.toString().split(".")[1]).length) == 1) {
            fctr = figure.toString().split(".")[1].concat("0");
        }        
    
        if (((figure.toString().split(".")[1]).length) > 2) {
            fctr = figure.toString().split(".")[1].substring(0,decimals);
        } 
        
        a = Math.trunc(figure) + "." + fctr;
        if(str.indexOf("-0") > -1)
            a= "-"+a;
        
    }  
    //console.log("a",a)
}else{
    a=figure;
}
    return a;
}

function getDateyyyymmddToExpected(dte, format) {
    dte = dte.toString();
    var now = new Date(dte.substring(4, 6) + " " + dte.substring(6, 8) + " " + dte.substring(0, 4));
    return dateFormat(now, format);
}

function getSelectDirectQ(resultView) {
    let queryStr = "pkt_idn,stock_idn,pkt_code,stock_type,status,qty_on_hand,weight_on_hand,attr ->> 'rap_rte' benchmark_rte,attr ->> 'rte' asking_rte,sort";
    let resultViewlen = resultView.length;
    for (let i = 0; i < resultViewlen; i++) {
        let attr = resultView[i];
        if (attr == 'crtwt')
            queryStr += ", trunc(CAST(attr ->> 'crtwt' as Numeric),2)  " + attr;
        else
            queryStr += ", attr ->> '" + attr + "' " + attr;
    }
    return queryStr;
}

function getSelectQ(resultView) {
    let queryStr = "stock_idn,pkt_code,stock_type,status, status stt,qty_on_hand,weight_on_hand,benchmark_rte,asking_rte,sort,dsp_stt,dsp_stt_color,grp_stt ";
    let resultViewlen = resultView.length;
    for (let i = 0; i < resultViewlen; i++) {
        let attr = resultView[i];
        if (attr == 'crtwt')
            queryStr += ", trunc(CAST(attr ->> 'crtwt' as Numeric),2)  " + attr;
        else
            queryStr += ",COALESCE(attr ->> '" + attr + "','') " + attr;
    }
    return queryStr;
}

function getSelectQMix(resultView) {
    let queryStr = "stock_idn,pkt_code,stock_type,status, status stt,qty_on_hand,weight_on_hand,benchmark_rte,asking_rte,sort,dsp_stt,dsp_stt_color,grp_stt ";
    let resultViewlen = resultView.length;
    for (let i = 0; i < resultViewlen; i++) {
        let attr = resultView[i];
        if (attr == 'crtwt')
        queryStr += ", trunc(CAST(attr ->> 'crtwt' as Numeric),3)  " + attr;
        else
            queryStr += ",COALESCE(attr ->> '" + attr + "','') " + attr;
    }
    return queryStr;
}

exports.packetCreation = function (methodParam, tpoolconn, callback) {
    var attrDtl = methodParam.attrDtl || {};
    var crtwt = methodParam.crtwt || '0';
    var logUsr = methodParam.logUsr;
    var coIdn = methodParam.coIdn || '';
    var stockIdn = methodParam.stockIdn || '';
    let stockTyp = methodParam.stockTyp || 'PC';
    let stockStatus = methodParam.stockStatus || 'PCHK';
    var benchmarkRte = methodParam.benchmarkRte || 1;
    var askingRte = methodParam.askingRte || 1;
    let qty = methodParam.qty || 1;
    crtwt = parseFloat(crtwt);

    let fmt = {};
    let params = [];
    let sqlQ = "";
    let outJson = {};
    let resultFinal = {};

    if (stockIdn != '') {
        var sql = "attr = attr ||  concat('" + JSON.stringify(attrDtl).replace(/'/g, "''") + "')::jsonb , ";//concat('" + JSON.stringify(attrDtl) + "')::jsonb

        if (crtwt > 0)
            sql += " weight_on_hand =" + crtwt + ",";

        var updateStock = "update stock_m set " + sql +
            "modified_ts=current_timestamp,modified_by=$3   where stock_idn = $1 and co_idn=$2 Returning attr->> 'sz' sz ";

        params = [];
        params.push(stockIdn);
        params.push(coIdn);
        params.push(logUsr);
        //console.log(updateStock)
        //console.log(params)
        coreDB.executeTransSql(tpoolconn, updateStock, params, fmt, function (error, result) {
            if (error) {
                coreDB.doTransRollBack(tpoolconn);
                outJson["status"] = "FAIL";
                outJson["message"] = "Fail To Update stock_m!" + error.message;
                outJson["result"] = resultFinal;
                callback(null, outJson);
            } else {
                //coreDB.doTransCommit(tpoolconn);
                let size = result.rows[0].sz || '';
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                outJson["stockIdn"] = stockIdn;
                outJson["size"] = size;
                callback(null, outJson);
            }
        })
    } else {
        methodParam = {};
        methodParam["seqNm"] = "stock_m_seq";
        coreUtil.getNextValFromSeq(tpoolconn, methodParam, function (error, seqresult) {
            if (seqresult["status"] == "SUCCESS") {
                var stockId = seqresult["result"];

                let vnm = attrDtl["vnm"] || '';
                let pkt_code = vnm;
                //if(vnm == ''){
                //    attrDtl["vnm"] = stockId;
                //    pkt_code = stockId;
                //}

                sqlQ = "insert into stock_m(stock_idn,co_idn,pkt_idn,stock_type,status,in_dte,qty_on_hand,weight_on_hand,attr,version,stt,start_dt,created_ts,created_by,benchmark_rte,asking_rte) \n " +
                    "values($1,$2,$3,$4,$5,current_date,$6,$7,concat('" + JSON.stringify(attrDtl).replace(/'/g, "''") + "')::jsonb,1,1,current_date,current_timestamp,$8,$9,$10) Returning pkt_code";
                    //,'" + JSON.stringify(attrDtl) + "'
                params.push(stockId);
                params.push(coIdn);
                params.push(stockId);
                //params.push(pkt_code);
                params.push(stockTyp);
                params.push(stockStatus);
                params.push(qty);
                params.push(crtwt);
                params.push(logUsr);
                params.push(benchmarkRte);
                params.push(askingRte);
                //console.log(sqlQ);
                //console.log(params);
                coreDB.executeTransSql(tpoolconn, sqlQ, params, fmt, function (error, result) {
                    if (error) {
                        outJson["status"] = "FAIL";
                        outJson["message"] = "Fail To Execute Query! " + error.message;;
                        console.log(outJson)
                        callback(null, outJson);
                    } else {
                        //coreDB.doTransCommit(tpoolconn);
                        var rowCount = result.rowCount;
                        if (rowCount > 0) {
                            pkt_code = result.rows[0].pkt_code || '';
                            let updateQ = "update stock_m set  tag_id = COALESCE(attr ->> 'rfidcd',''),"+  
                            " attr = attr || concat('{\"gsz\":', get_attr_by_criteria($1, stock_idn, 'attr', 'gsz') "+
                            ",',\"rap_rte\":',get_benchmark_rte(stock_idn) "+
                            ",',\"sz\":',  get_attr_by_criteria($2, stock_idn, 'attr', 'sz') "+
                            ",',\"measurement\":\"'||get_measurement(stock_idn)||'\"' "+
                            ",',\"lw\":\"'||get_lwr(stock_idn)||'\"' "+
                            ",'}')::jsonb "+
                            ", modified_ts = current_timestamp, modified_by = $3 " +
                            "  where stock_idn = $4   "+
                            " and co_idn = $5 and stt=1 Returning attr->> 'sz' sz ";
            
                            params = [];
                            params.push(coIdn);
                            params.push(coIdn);
                            params.push(logUsr);
                            params.push(stockId);
                            params.push(coIdn);
                            //console.log(updateQ);
                            //console.log(params);
                            coreDB.executeTransSql(tpoolconn, updateQ, params, {},function (error, result) {
                                if (error) {
                                    coreDB.doTransRollBack(tpoolconn);
                                    outJson["status"] = "SUCCESS";
                                    outJson["message"] = "Error In update stock_m Method!" + error.message;
                                    outJson["stockIdn"] = stockId;
                                    outJson["pkt_code"] = pkt_code;
                                    console.log(outJson);
                                    callback(null, outJson);
                                } else {
                                    //coreDB.doTransCommit(tpoolconn);
                                    let size = result.rows[0].sz || '';
                                    
                                    outJson["status"] = "SUCCESS";
                                    outJson["message"] = "Packet Created Sucessfully";
                                    outJson["stockIdn"] = stockId;
                                    outJson["pkt_code"] = pkt_code;
                                    outJson["size"] = size;
                                    callback(null, outJson);
                                }
                            })
                        } else {
                            outJson["status"] = "FAIL";
                            outJson["message"] = "Fail To Create Packet!";
                            callback(null, outJson);
                        }  
                    }
                });
            } else {
                callback(null, seqresult);
            }
        })
    }
}


exports.getPacketDtlOld =  function(paramJson,connection,callback) {
    var coIdn = paramJson.coIdn;
    let attrValType = paramJson.attrValType || 'Print';
    let source = paramJson.source;
    let packetIdnList = paramJson.packetIdnList;
    let formNme = paramJson.formNme;
    let displayKey = paramJson.displayKey;
    let formatName = paramJson.formatName || null;
    let pvtConfigure = paramJson.pvtConfigure;
    let userIdn = paramJson.userIdn;
    let applIdn = paramJson.applIdn;
    let statusList = paramJson.statusList || [];
    let statusListLen = statusList.length;
    let fncycoLock = paramJson.fncycoLock||'Y';
    let prefix = paramJson.prefix || '';


    let outJson = {};
    var map = [];
    let dataTypeFormatDtl={};
    let attrDisplayDtl={};
    let attrDisplayType={};
    let formulaAttr=[];
    var cachedUrl = require('qaq-core-util').cachedUrl;
    let resultView = [];
    let methodParam = {};

    methodParam["formName"]=formNme;
    methodParam["display_key"]=displayKey;
    methodParam["nme"]=formatName;
    methodParam["userIdn"]=userIdn;
    methodParam["coIdn"]=coIdn;
    methodParam["db"]=connection;
    methodParam["userCtg"]=pvtConfigure;
    methodParam["prefix"] = prefix;
    coreUtil.pageDisplay(methodParam).then(attrresult =>{
        resultView=attrresult.attr || [];
        let resultViewlen=resultView.length;

        coreUtil.getCache(prefix+"productAttributeM_"+coIdn,cachedUrl).then(productAttributeM =>{
            if(productAttributeM == null){
                outJson["status"]="FAIL";
                outJson["message"]="Fail to get Product Attribute";
                callback(null,outJson);
            }else{
                productAttributeM = JSON.parse(productAttributeM);
                let attrs = productAttributeM["ALL"] || [];
                methodParam = {};
                methodParam["source"] = source;
                methodParam["applIdn"] = applIdn;
                methodParam["coIdn"] = coIdn;
                methodParam["searchView"] = attrs;
                methodParam["attrSortYN"] = 'Y';
                methodParam["prefix"] = prefix;
                coreUtil.execattrStructureDtlWitoutGroup(methodParam, connection).then(attrStructureDtlResult =>{
                    if (attrStructureDtlResult.status == "SUCCESS" && attrStructureDtlResult.message == "SUCCESS") 
                        outJson["attrStructureDtl"] = attrStructureDtlResult.attrStructureDtl;
                    else  
                        outJson["attrStructureDtl"] = [];
            
                    for(let j=0;j<resultViewlen;j++){
                        let attr=resultView[j];
                        let data_typ=productAttributeM[attr+"#T"] || '';
                        let display=productAttributeM[attr+"#DS"] || '';
                        let web=productAttributeM[attr+"#W"] || '';
                        let format=productAttributeM[attr+"#F"] || '';
                        let formula=productAttributeM[attr+"#FL"] || '';
                        dataTypeFormatDtl[attr]=data_typ;
                        dataTypeFormatDtl[attr+"#F"]=format;
                        dataTypeFormatDtl[attr+"#FL"]=formula;
                        if(data_typ=='f'){
                            formulaAttr.push(attr);
                            if(formula!='')
                            dataTypeFormatDtl[attr+"#FL#ATTR"]=coreUtil.getDependAttrList(formula);
                        }
                        attrDisplayDtl[attr]=display;
                        attrDisplayType[attr]=data_typ;
                    }
            
                    outJson["attrs"]=resultView;
                    outJson["attrDisplayDtl"]=attrDisplayDtl;
                    outJson["attrDisplayType"]=attrDisplayType;
                    coreUtil.getCache(prefix+"productAttributeDtl_"+coIdn,cachedUrl).then(productAttributeDtl =>{
                        if(productAttributeDtl == null){
                            outJson["status"]="FAIL";
                            outJson["message"]="Fail to get Product Sub Attribute";
                            callback(null,outJson);
                        }else{
                            productAttributeDtl = JSON.parse(productAttributeDtl);

                            let fmt = {};
                            let params=[];
                            let conQ = "";
                            if(statusListLen > 0){
                                conQ = "  and status in ('" + statusList.join("','") + "') ";
                            }

                            var sql="select stock_idn,pkt_code, "+
                            " CASE benchmark_rte WHEN '1' THEN null ELSE ((CAST(attr ->> 'rte' as Numeric)*100/CAST(attr ->> 'rap_rte' as Numeric))-100) END rate_dis  ,"+
                            " stock_type,status stt,attr ->> 'certno' certno,attr ->> 'cert_image' cert_image,sort , "+
                            " attr->> 'rap_rte' raprte , attr ->> 'fancy_co' fancyco  ";
                            
                            for (let i = 0; i < resultViewlen; i++){
                                let attr= resultView[i];
                                //sql+=", attr ->> '"+attr+"' "+attr;
                                if(attr=='crtwt')
                                    sql += ", trunc(CAST(attr ->> 'crtwt' as Numeric),2)  " + attr;
                                else
                                    sql += ",COALESCE(attr ->> '" + attr + "','') " + attr;
                            }
                            sql+=" from stock_m  where  "+
                                "co_idn=$1 and stt=1 and (pkt_code = ANY(ARRAY['"+packetIdnList.join("','")+"']) "+
                                "OR attr ->> 'certno' = ANY(ARRAY['"+packetIdnList.join("','")+"']) "+
                                "OR tag_id = ANY(ARRAY['"+packetIdnList.join("','")+"'])) "+ conQ +
                                "order by sort";
                        
                            params.push(coIdn);

                            //console.log(sql);
                            //console.log(params);
                            coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
                                if(error){
                                    outJson["status"]="FAIL";
                                    outJson["message"]="Error In getPacketDetails Method!"+error;
                                    callback(null,outJson);
                                }else{
                                    var len=result.rows.length;
                                    var statusList = [];
                                    if(len>0){
                                        for(let i =0 ;i<len;i++){                                   
                                            let data = result.rows[i];   
                                            var k = {};
                                            k["packet"]=data.pkt_code;
                                            k["certno"]=data.certno;   
                                            k["cert_image"]=data.cert_image;                         
                                            let stock_type=data.stock_type;
                                            var rapRte=parseInt(data['raprte']);

                                            for(let j=0;j<resultViewlen;j++){
                                                let attr=resultView[j];
                                                let data_typ=dataTypeFormatDtl[attr] || '';
                                                let attrVal=data[attr];
                                                if(data_typ=='c' && attrVal!='' && attrVal!=0 && attrValType == 'Print'){
                                                let prpSort=productAttributeDtl[attr+"#S"] || [];
                                                let prpDisplay=productAttributeDtl[attr+"#P"] || [];
                                                let prpWeb=productAttributeDtl[attr+"#W"] || [];
                                                if(source=='qsol' || source=='qs'){
                                                attrVal=prpDisplay[prpSort.indexOf(parseInt(attrVal))];
                                                }else{
                                                attrVal=prpWeb[prpSort.indexOf(parseInt(attrVal))];
                                                }
                                                }else if(data_typ=='d' && attrVal!='' && attrVal!=0){
                                                attrVal=coreUtil.getDateyyyymmddToExpected(attrVal,'dd-mmm-yyyy');
                                                }else if(data_typ=='n'&& attrVal!='' && attrVal!=0){
                                                let format=dataTypeFormatDtl[attr+"#F"] || 'N';
                                                if(format!='N'){
                                                if(stock_type!='NR' && attr=="crtwt"){
                                                format=3;
                                                }
                                                attrVal=attrVal || 0;
                                                //console.log("Format"+format+"before"+attrVal);
                                                attrVal=coreUtil.floorFigure(attrVal,format);
                                                //console.log("after"+attrVal);
                                                }
                                                }
                                                k[attr]=attrVal;

                                                if(attr=="crtwt"){
                                                    k["rap_vlu"]= rapRte * parseFloat(attrVal);
                                                }
                                                    
                                            }
                                            k["stock_idn"] = data.stock_idn;
                                            k["rap_dis"] = coreUtil.floorFigure(data.rate_dis||0,2);
                                            k["benchmark_rte"] = k.rap_rte;
                                            k["sort"] = data.sort;
                                            k["stock_type"] = stock_type;
                                            k["status"] = data.stt;
                                            k["pkt_code"]=data.pkt_code;
                                           
                                            let co =  k["co"]||'';
                                           if(co=='FANCY' && fncycoLock=='Y'){
                                          attrVal = data.fancyco; 
                                           k['co'] = attrVal;
                                           }
                                            map.push(k);                                      
                                        }
                                        outJson["status"]="SUCCESS";
                                        outJson["message"]="SUCCESS";
                                        outJson["result"]=map;
                                        callback(null,outJson);
                                    }else{
                                        outJson["status"]="FAIL";
                                        outJson["message"]="Sorry result not found";
                                        outJson["result"]=map;
                                        callback(null,outJson);
                                    }
                                }
                            });  
                        }
                    })
                })
            }
        })
    })
}

exports.getPacketDtl =  function(paramJson,connection,callback) {
    var coIdn = paramJson.coIdn;
    let attrValType = paramJson.attrValType || 'Print';
    let source = paramJson.source;
    let packetIdnList = paramJson.packetIdnList;
    let formNme = paramJson.formNme;
    let displayKey = paramJson.displayKey;
    let formatName = paramJson.formatName || null;
    let pvtConfigure = paramJson.pvtConfigure;
    let userIdn = paramJson.userIdn;
    let applIdn = paramJson.applIdn;
    let statusList = paramJson.statusList || [];
    let statusListLen = statusList.length;
    let fncycoLock = paramJson.fncycoLock||'Y';
    let searchType = paramJson.searchType || 'vnm';
    let imagePrpList = paramJson.imagePrpList || [];
    let imageDtl = paramJson.imageDtl || {};
    let prefix = paramJson.prefix || '';
    let srtYN = paramJson.srtYN || 'N';

    let outJson = {};
    var map = [];
    let dataTypeFormatDtl={};
    let attrDisplayDtl={};
    let attrDisplayType={};
    let formulaAttr=[];
    var cachedUrl = require('qaq-core-util').cachedUrl;
    let resultView = [];
    let methodParam = {};

    methodParam["formName"]=formNme;
    methodParam["display_key"]=displayKey;
    methodParam["nme"]=formatName;
    methodParam["userIdn"]=userIdn;
    methodParam["coIdn"]=coIdn;
    methodParam["db"]=connection;
    methodParam["userCtg"]=pvtConfigure;
    methodParam["prefix"] = prefix;
    coreUtil.pageDisplay(methodParam).then(attrresult =>{
        resultView=attrresult.attr || [];
        let resultViewlen=resultView.length;
        outJson["attrs"]=resultView;

        coreUtil.getCache(prefix+"productAttributeM_"+coIdn,cachedUrl).then(productAttributeM =>{
            if(productAttributeM == null){
                outJson["status"]="FAIL";
                outJson["message"]="Fail to get Product Attribute";
                callback(null,outJson);
            }else{
                productAttributeM = JSON.parse(productAttributeM);
                let attrs = productAttributeM["ALL"] || [];
                methodParam = {};
                methodParam["source"] = source;
                methodParam["applIdn"] = applIdn;
                methodParam["coIdn"] = coIdn;
                methodParam["searchView"] = attrs;
                methodParam["attrSortYN"] = 'Y';
                methodParam["prefix"] = prefix;
                coreUtil.execattrStructureDtlWitoutGroup(methodParam, connection).then(attrStructureDtlResult =>{
                    if (attrStructureDtlResult.status == "SUCCESS" && attrStructureDtlResult.message == "SUCCESS") 
                        outJson["attrStructureDtl"] = attrStructureDtlResult.attrStructureDtl;
                    else  
                        outJson["attrStructureDtl"] = [];

                    resultView = resultView.concat(imagePrpList);
                    resultViewlen = resultView.length;   
            
                    for(let j=0;j<resultViewlen;j++){
                        let attr=resultView[j];
                        let data_typ=productAttributeM[attr+"#T"] || '';
                        let display=productAttributeM[attr+"#DS"] || '';
                        let web=productAttributeM[attr+"#W"] || '';
                        let format=productAttributeM[attr+"#F"] || '';
                        let formula=productAttributeM[attr+"#FL"] || '';
                        dataTypeFormatDtl[attr]=data_typ;
                        dataTypeFormatDtl[attr+"#F"]=format;
                        dataTypeFormatDtl[attr+"#FL"]=formula;
                        if(data_typ=='f'){
                            formulaAttr.push(attr);
                            if(formula!='')
                            dataTypeFormatDtl[attr+"#FL#ATTR"]=coreUtil.getDependAttrList(formula);
                        }
                        attrDisplayDtl[attr]=display;
                        attrDisplayType[attr]=data_typ;
                    }
            
                   
                    outJson["attrDisplayDtl"]=attrDisplayDtl;
                    outJson["attrDisplayType"]=attrDisplayType;
                    coreUtil.getCache(prefix+"productAttributeDtl_"+coIdn,cachedUrl).then(productAttributeDtl =>{
                        if(productAttributeDtl == null){
                            outJson["status"]="FAIL";
                            outJson["message"]="Fail to get Product Sub Attribute";
                            callback(null,outJson);
                        }else{
                            productAttributeDtl = JSON.parse(productAttributeDtl);

                            let fmt = {};
                            let params=[];
                            let conQ = "";
                            if(statusListLen > 0){
                                conQ = "  and status in ('" + statusList.join("','") + "') ";
                            }

                            if(searchType == 'vnm'){
                                let packetList = packetIdnList.map(packetIdn => packetIdn.toUpperCase());
                                conQ = "  and pkt_code = ANY(ARRAY['"+packetList.join("','")+"']) ";
                            } else if(searchType == 'tag_id'){
                                conQ = "  and tag_id = ANY(ARRAY['"+packetIdnList.join("','")+"']) ";
                            } else if(searchType == 'cert_no'){
                                conQ = " and stock_type='NR' and attr ->> 'certno' = ANY(ARRAY['"+packetIdnList.join("','")+"']) ";
                            } 

                            var sql="select stock_idn,pkt_code, "+
                            " stock_type,status stt,attr ,trunc(CAST(attr ->> 'crtwt' as Numeric),2) crtwts,sort "+
                            " from stock_m  where  "+
                            "co_idn=$1 and stt=1 "+ conQ ;
                            //"order by sort";
                        
                            params.push(coIdn);

                            //console.log(sql);
                           //console.log(params);
                            coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
                                if(error){
                                    outJson["status"]="FAIL";
                                    outJson["message"]="Error In getPacketDetails Method!"+error;
                                    callback(null,outJson);
                                }else{
                                    var len=result.rows.length;
                                    var statusList = [];
                                    //console.log("length",len)
                                    if(len>0){
                                        for(let i =0 ;i<len;i++){                                   
                                            let data = result.rows[i];   
                                            var k = {};
                                            let attrDtl = data.attr || {};
                                            k["packet"]=data.pkt_code;
                                            k["certno"]=attrDtl.certno;   
                                            k["cert_image"]=attrDtl.cert_image;                         
                                            let stock_type=data.stock_type;
                                            //console.log("attrDtl['raprte']",attrDtl['rap_rte'])
                                            var rapRte=parseInt(attrDtl['rap_rte']  || 1);
                                           // console.log(resultView)
                                            for(let j=0;j<resultViewlen;j++){
                                                let attr=resultView[j];
                                                let data_typ=dataTypeFormatDtl[attr] || '';
                                                let attrVal = attrDtl[attr] || '';
                                                
                                                if(data_typ=='c' && attrVal!='' && attrVal!=0 && attrValType == 'Print'){
                                                    if(srtYN == 'Y' || srtYN == 'y')
                                                        k[attr+"_sort"]=attrVal;
                                                    
                                                    let prpSort=productAttributeDtl[attr+"#S"] || [];
                                                    let prpDisplay=productAttributeDtl[attr+"#P"] || [];
                                                    let prpWeb=productAttributeDtl[attr+"#W"] || [];
                                                    if(source=='qsol' || source=='qs'){
                                                        attrVal=prpDisplay[prpSort.indexOf(parseInt(attrVal))];
                                                    }else{
                                                        attrVal=prpWeb[prpSort.indexOf(parseInt(attrVal))];
                                                    }
                                                    if(attrVal == 'NA' || attrVal == 'na')
                                                        attrVal = '';
                                                }else if(data_typ=='d' && attrVal!='' && attrVal!=0){
                                                    //console.log("attr",attr,"attrVal",attrVal)
                                                    attrVal=coreUtil.getDateyyyymmddToExpected(attrVal,'dd-mmm-yyyy');
                                                }else if(data_typ=='n'&& attrVal!='' && attrVal!=0){
                                                    let format=dataTypeFormatDtl[attr+"#F"] || 'N';
                                                    if(format!='N'){
                                                        if(stock_type!='NR' && attr=="crtwt"){
                                                            format=3;
                                                        }
                                                        attrVal=attrVal || 0;
                                                        //console.log("Format"+format+"before"+attrVal);
                                                        attrVal=coreUtil.floorFigure(attrVal,format);
                                                        //console.log("after"+attrVal);
                                                    }
                                                }
                                                //console.log("attr",attr,"attrVal",attrVal)
                                                k[attr]=attrVal;

                                                if(attr=="crtwt"){
                                                    k["rap_vlu"]= rapRte * parseFloat(attrVal);
                                                    //console.log(" rap_vlu", k["rap_vlu"]);
                                                }
                                                    
                                            }
                                            k["stock_idn"] = data.stock_idn;
                                            k["crtwt"] = data.crtwts;
                                            //console.log("k",k);
                                            if(rapRte == 1){
                                                k["rap_dis"] = null;
                                            } else {
                                                let rte = attrDtl.rte || 1;
                                                //console.log("rte",rte);
                                                //console.log("rapRte",rapRte);
                                                let rate_dis = ((parseFloat(rte)*100/rapRte)-100) || 0;
                                                //console.log("rate_dis",rate_dis);
                                                k["rap_dis"] = coreUtil.floorFigure(rate_dis,2);
                                            }
                                           
                                            
                                            k["benchmark_rte"] = k.rap_rte;
                                            k["sort"] = parseInt(data.sort);
                                            k["stock_type"] = stock_type;
                                            k["status"] = data.stt;
                                            k["pkt_code"]=data.pkt_code;
                                           
                                            let co =  k["co"]||'';
                                           if(co=='FANCY' && fncycoLock=='Y'){
                                                attrVal = attrDtl.fancy_co || ''; 
                                                k['co'] = attrVal;
                                           }
                                           //console.log("K",k);
                                            map.push(k);                                      
                                        }
                                        map.sort((a, b) => (a.sort > b.sort) ? 1 : -1);
                                        outJson["status"]="SUCCESS";
                                        outJson["message"]="SUCCESS";
                                        outJson["result"]=map;
                                        callback(null,outJson);
                                    }else{
                                        outJson["status"]="FAIL";
                                        outJson["message"]="Sorry result not found";
                                        outJson["result"]=map;
                                        callback(null,outJson);
                                    }
                                }
                            });  
                        }
                    })
                })
            }
        })
    })
}

exports.getKtsAttr = function(methodParam, connection, callback) {
    let productAttributeM = methodParam.productAttributeM;
    let productAttributeDtl = methodParam.productAttributeDtl;
    let coIdn = methodParam.coIdn;
    let ktsList = [];
    let ktsAttrList = [];

    let params = [coIdn];
    let outJson = {};

    let sql = "select srt, "+
        " attr,dta_typ "+
        "from product_attr_m pm "+ 
        "where 1=1 and pm.ui_grp='kts' and pm.stt=1 and $1=ANY(ARRAY[pm.co_allow]) ";

    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(connection, sql, params, {}, async function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In select ktsattr of process Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                for (let i = 0; i < len; i++) {
                    let map = {};
                    let attr = result.rows[i].attr || "";
                    let data_typ = result.rows[i].dta_typ || ''; 
                    map["attr"] = attr;
                    let srt = result.rows[i].srt || 0;
                    map["sort"] = parseInt(srt);
                    let print = productAttributeM[attr] || '';
                    map["data_typ"] = data_typ;
                    map["print"] = print;
                    
                    if (data_typ == 'c') {
                        var prpVal = productAttributeDtl[attr + "#V"] || [];
                        var prpSort = productAttributeDtl[attr + "#S"] || [];
                            map["prpval"] = prpVal;
                            map["prpsort"] = prpSort;                        
                    }
                    ktsList.push(map);
                    ktsAttrList.push(attr);
                }
                 //ktsList.sort((val1, val2) => {
                //    return (val1.print) - (val2.print);
                //});
                ktsList.sort((a, b) => (a.print > b.print) ? 1 : -1)


                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                outJson["result"] = ktsList;
                outJson["ktsAttrList"] = ktsAttrList;
                callback(null, outJson);  
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Please verify kts attr for selected process";
                outJson["result"] = ktsList;
                callback(null, outJson);
            }
        }
    })
}

exports.getRfidDevice = function (connection, paramJson, callback) {
    var coIdn = paramJson.coIdn || '';
    let prefix = paramJson.prefix || '';
    var outJson = {};
    var attrDtlLst = [];
    var cachedUrl = require('qaq-core-util').cachedUrl;

    coreUtil.getCache(prefix+"attributeMasterDtl_" + coIdn, cachedUrl).then(attrDtldata => {
        if (attrDtldata == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Contact Attribute";
            callback(null, outJson);
        } else {
            attrDtldata = JSON.parse(attrDtldata);
            var print = attrDtldata["rfid_device#P"] || [];
            var idn = attrDtldata["rfid_device#I"] || [];

            for (var i = 0; i < idn.length; i++) {
                var attrDtl = {};
                attrDtl["idn"] = idn[i];
                attrDtl["print"] = print[i];
                attrDtlLst.push(attrDtl);
            }
            outJson["result"] = attrDtlLst;
            outJson["status"] = "SUCCESS";
            outJson["message"] = "SUCCESS";
            callback(null, outJson);
        }
    })
}

exports.deleteNonBidPacket = function(methodParam, tpoolconn, callback) {
    let coIdn = methodParam.coIdn;

    let fmt = {};
    let params = [];
    let outJson = {};
    let sql = "delete from temp_stock_search_pkts s "+
            "where 1 = 1 "+
            "and s.status = ANY(select iss_status "+
            "from stock_process p CROSS JOIN jsonb_array_elements(settings -> 'settingsDtl') s1 "+
            "where s1 ->> 'attr' = 'auction_status' and lower(s1 ->> 'val') = 'on') "+
            "and not exists (select 1 "+
            "from transaction_web w, transaction_d_web dw "+
            ", stock_process p CROSS JOIN jsonb_array_elements(settings -> 'settingsDtl') s1 "+
            "where s1 ->> 'attr' = 'auction_status' and lower(s1 ->> 'val') = 'on' "+
            "and p.process_idn = w.process_idn "+
            "and w.transaction_web_idn = dw.transaction_web_idn "+
            "and s.stock_idn = dw.stock_idn "+
            "and p.co_idn = $1 and p.stt=1 and p.co_idn=w.co_idn "+
            "and s.status = ANY(p.in_status) "+
            "and dw.status = 'IS' ) ";

        params.push(coIdn);

    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In deleteNonBidPacket Method!" + error.message;
            console.log(outJson);
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            //console.log("len",len);
            if (len > 0) {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            }
        }
    });
}

exports.deleteUpcomingPacket = function(methodParam, tpoolconn, callback) {
    let coIdn = methodParam.coIdn;

    let fmt = {};
    let params = [];
    let outJson = {};
    let sql = "delete from temp_stock_search_pkts s "+
            "where 1 = 1 "+
            "and s.attr ->> 'upcoming_yn' = '20' ";

    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In deleteUpcomingPacket Method!" + error.message;
            console.log(outJson);
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            let map = {};
            map["quot"] = '0';
            //console.log("len",len);
            let sql = "update temp_stock_search_pkts set attr = attr || '"+JSON.stringify(map)+"' "+
                "where 1 = 1 "+
                "and attr ->> 'upcoming_yn' = '20' ";

            //console.log(sql);
            //console.log(params);
            coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
                if (error) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Error In updateUpcomingPacket Method!" + error.message;
                    console.log(outJson);
                    callback(null, outJson);
                } else {
                    len = result.rows.length;
            
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                }
            })
        }
    });
}

exports.doApplyBenchmark = function ( redirectParam,tpoolconn, callback) {
    let coIdn = redirectParam.coIdn;
    let stock_idn = redirectParam.stock_idn || '';
    let outJson={};
    let resultFinal = {};
    let params = [];
    let fmt = {};

    if(stock_idn != ''){
        let query = "select do_apply_benchmark($1,'default',$2) ";
        params.push(coIdn);
        params.push(stock_idn);
        console.log(query);
        console.log(params);
        coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
            if (error) {
                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["message"] = "do_apply_benchmark Fail To Execute Query!";
                callback(null, outJson);
            } else {
                let rowCount = result.rowCount;
                //console.log("rowCount",rowCount)
                if (rowCount > 0) {
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "RapRte apply successfully";
                    callback(null, outJson);
                } else {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to execute do_apply_benchmark";
                    callback(null, outJson);
                }
            }
        });
    } else {
        outJson["status"] = "FAIL";
        outJson["message"] = "Stock idn can not be blank for do_apply_benchmark";
        callback(null, outJson);
    }
}

exports.getAndUpdateBenchmark = function ( redirectParam,tpoolconn, callback) {
    let coIdn = redirectParam.coIdn;
    let stock_idn = redirectParam.stock_idn || '';
    let logUsr = redirectParam.logUsr;
    let outJson={};
    let resultFinal = {};
    let params = [];
    let fmt = {};

    if(stock_idn != ''){
        let query = "select get_benchmark_rte($1) rap_rte ";

        params.push(stock_idn);
        //console.log(query);
        //console.log(params);
        coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
            if (error) {
                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["message"] = "get_benchmark_rte Fail To Execute Query!"+error.message;
                callback(null, outJson);
            } else {
                let rowCount = result.rowCount;
                if (rowCount > 0) {
                    let rap_rte = result.rows[0].rap_rte || '';

                    let attrDtl={};
                    attrDtl["rap_rte"] = rap_rte;

                    let updateQ = "update stock_m set "+
                            " attr = attr || '" + JSON.stringify(attrDtl) + "' "+
                            ", modified_ts = current_timestamp, modified_by = $1 " +
                            "  where stock_idn = $2  "+
                            " and co_idn = $3 and stt=1 ";

                        params = [];
                        params.push(logUsr);
                        params.push(stock_idn);
                        params.push(coIdn);
                        //console.log(updateQ);
                        //console.log(params);
                        coreDB.executeTransSql(tpoolconn, updateQ, params, {}, function (error, result) {
                            if (error) {
                                coreDB.doTransRollBack(tpoolconn);
                                outJson["status"] = "FAIL";
                                outJson["message"] = "Error In update stock_m Method!" + error.message;
                                console.log(outJson);
                                callback(null, outJson);
                            } else {
                                //coreDB.doTransCommit(tpoolconn);
                                outJson["status"] = "SUCCESS";
                                outJson["message"] = "RapRte apply successfully";
                                callback(null, outJson);     
                            }
                        })
                } else {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to execute get_benchmark_rte";
                    callback(null, outJson);
                }
            }
        });
    } else {
        outJson["status"] = "FAIL";
        outJson["message"] = "Stock idn can not be blank for get_benchmark_rte";
        callback(null, outJson);
    }
}

exports.createMixMktPacket =async function(methodParam, tpoolconn, callback) {
    var attrDtl = methodParam.attrDtl;
    let qty = methodParam.qty;
    var crtwt = parseFloat(methodParam.crtwt);
    var logUsr = methodParam.logUsr;
    var coIdn = methodParam.coIdn || '';
    let stockTyp = methodParam.stockTyp || 'MIX';
    let stockStatus = methodParam.stockStatus || '';
    var benchmarkRte = methodParam.benchmarkRte || 1;
    var askingRte = methodParam.askingRte || 1;
    let rootPacket = methodParam.rootPacket || '';
    let prefix = methodParam.prefix || '';
    var now = new Date();
    attrDtl["trf_dte"]=dateFormat(now,'yyyymmdd');
    let loc = attrDtl.loc || '';
    if(loc == '' || loc == 0 || loc == null){
        var cachedUrl = require('qaq-core-util').cachedUrl;
        let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl);
        if(dbmsDtldata == null){
                outJson["status"]="FAIL";
                outJson["message"]="Fail to get DBMS Attribute";
                callback(null,outJson);
        }else{ 
            dbmsDtldata = JSON.parse(dbmsDtldata); 

            let default_loc = dbmsDtldata["default_loc"];
            //console.log("loc",loc);
            let productAttributeDtl = await coreUtil.getCache(prefix+"productAttributeDtl_"+coIdn,cachedUrl);
            if(productAttributeDtl == null){
                outJson["status"]="FAIL";
                outJson["message"]="Fail to get Product Sub Attribute";
                callback(null,outJson);
            }else{
                productAttributeDtl = JSON.parse(productAttributeDtl);
                let attr = "loc";
                let prpSort=productAttributeDtl[attr+"#S"] || [];
                let prpVal=productAttributeDtl[attr+"#V"] || [];
                loc = prpSort[prpVal.indexOf(default_loc)] || '';
            }
        }
    }
    attrDtl["loc"]=loc;

    let cp = attrDtl["cp"] || '1';
    if(rootPacket != '' && cp == '1'){
        let paramJson = {};
        paramJson["rootPacket"] = rootPacket;
        paramJson["coIdn"] = coIdn;
        let cpResult = await execGetStockMCPrice(paramJson,tpoolconn);
        if(cpResult.status == 'SUCCESS'){
            cp = cpResult.result || '1'; 
        }
    }
    attrDtl["cp"]=cp;
    if(rootPacket != '')
        attrDtl["rt_pkt"] = rootPacket;

    let fmt = {};
    let params = [];
    let outJson = {};
    let resultFinal = {};

    let methodParams = {};
    methodParams["seqNm"] = "stock_m_seq";
    coreUtil.getNextValFromSeq(tpoolconn, methodParams, function (error, seqresult) {
        if (seqresult["status"] == "SUCCESS") {
            var stockId = seqresult["result"];

            //attrDtl["vnm"] = stockId;

            let sqlQ = "insert into stock_m(stock_idn,co_idn,pkt_idn,stock_type,status,in_dte,qty_on_hand,weight_on_hand,attr,version,stt,start_dt,created_ts,created_by,benchmark_rte,asking_rte) \n " +
                "values($1,$2,$3,$4,$5,current_date,$6,$7,'" + JSON.stringify(attrDtl) + "',1,1,current_date,current_timestamp,$8,$9,$10)";

            params.push(stockId);
            params.push(coIdn);
            params.push(stockId);
            //params.push(stockId);
            params.push(stockTyp);
            params.push(stockStatus);
            params.push(qty);
            params.push(crtwt);
            params.push(logUsr);
            params.push(benchmarkRte);
            params.push(askingRte);
            //console.log(sqlQ);
            //console.log(params);
            coreDB.executeTransSql(tpoolconn, sqlQ, params, fmt,async function (error, result) {
                if (error) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail To Execute Query! " + error.message;;
                    console.log(outJson)
                    callback(null, outJson);
                } else {
                    //coreDB.doTransCommit(tpoolconn);
                    var rowCount = result.rowCount;
                    if (rowCount > 0) {
                        let stockIdnList = [];
                        stockIdnList.push(stockId);
                        methodParams = {};
                        methodParams["stockIdnList"] = stockIdnList;
                        methodParams["logUsr"] = logUsr;
                        methodParams["coIdn"] = coIdn;
                        let stockMUpdateResult = await coreUtil.execUpdatePacketSort(methodParams, tpoolconn);
                        if (stockMUpdateResult["status"] == 'SUCCESS') {
                            if(rootPacket != ''){
                                qty = parseInt(qty);
                                crtwt = parseFloat(crtwt);
                               
                                let updateQ = "update stock_m  set "+
                                " qty_on_hand = qty_on_hand - "+qty+
                                " ,weight_on_hand = cast(weight_on_hand as numeric) - "+crtwt+
                                " ,attr = attr || concat('{\"qty\":', qty_on_hand - "+qty+",',\"crtwt\":',cast(attr->> 'crtwt' as numeric) - "+crtwt+",'}')::jsonb "+
                                ", modified_ts = current_timestamp, modified_by = $1 " +
                                " where  "+
                                " stt = 1 and stock_idn = $2 and co_idn=$3 "; 

                                params = [];
                                params.push(logUsr);
                                params.push(rootPacket);
                                params.push(coIdn);
                                //console.log(updateQ);
                                //console.log(params);
                                coreDB.executeTransSql(tpoolconn, updateQ, params, {}, function (error, result) {
                                    if (error) {
                                        coreDB.doTransRollBack(tpoolconn);
                                        console.log(error);
                                        outJson["status"] = "FAIL";
                                        outJson["message"] = "Error In update stock_m Method!" + error.message;
                                        console.log(outJson);
                                        callback(null, outJson);
                                    } else {
                                        //coreDB.doTransCommit(tpoolconn);
                                        outJson["status"] = "SUCCESS";
                                        outJson["message"] = "Packet Created Sucessfully";
                                        outJson["stockIdn"] = stockId;
                                        callback(null, outJson);
                                    }
                                })
                            } else {
                                outJson["status"] = "SUCCESS";
                                outJson["message"] = "Packet Created Sucessfully";
                                outJson["stockIdn"] = stockId;
                                callback(null, outJson);
                            }
                        } else {
                            callback(null,stockMUpdateResult);
                        }
                    } else {
                        outJson["status"] = "FAIL";
                        outJson["message"] = "Fail To Create Packet!";
                        callback(null, outJson);
                    } 
                }
            });
        } else {
            callback(null, seqresult);
        }
    })
}

exports.createMixAsrtPacket = async function(methodParam, tpoolconn, callback) {
    var attrDtl = methodParam.attrDtl;
    let qty = methodParam.qty;
    var crtwt = methodParam.crtwt;
    var logUsr = methodParam.logUsr;
    var coIdn = methodParam.coIdn || '';
    let stockTyp = methodParam.stockTyp || 'MIX';
    let stockStatus = methodParam.stockStatus || '';
    var benchmarkRte = methodParam.benchmarkRte || 1;
    var askingRte = methodParam.askingRte || 1;
    let rootPacket = methodParam.rootPacket || '';
    let prefix = methodParam.prefix || '';
    var now = new Date();
    attrDtl["trf_dte"]=dateFormat(now,'yyyymmdd');
    let loc = attrDtl.loc || '';
    if(loc == '' || loc == 0 || loc == null){
        var cachedUrl = require('qaq-core-util').cachedUrl;
        let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl);
        if(dbmsDtldata == null){
                outJson["status"]="FAIL";
                outJson["message"]="Fail to get DBMS Attribute";
                callback(null,outJson);
        }else{ 
            dbmsDtldata = JSON.parse(dbmsDtldata); 

            let default_loc = dbmsDtldata["default_loc"];
            //console.log("loc",loc);
            let productAttributeDtl = await coreUtil.getCache(prefix+"productAttributeDtl_"+coIdn,cachedUrl);
            if(productAttributeDtl == null){
                outJson["status"]="FAIL";
                outJson["message"]="Fail to get Product Sub Attribute";
                callback(null,outJson);
            }else{
                productAttributeDtl = JSON.parse(productAttributeDtl);
                let attr = "loc";
                let prpSort=productAttributeDtl[attr+"#S"] || [];
                let prpVal=productAttributeDtl[attr+"#V"] || [];
                loc = prpSort[prpVal.indexOf(default_loc)] || '';
            }
        }
    }
    attrDtl["loc"]=loc;

    let fmt = {};
    let params = [];
    let outJson = {};
    let resultFinal = {};

    let methodParams = {};
    methodParams["seqNm"] = "stock_m_seq";
    coreUtil.getNextValFromSeq(tpoolconn, methodParams, function (error, seqresult) {
        if (seqresult["status"] == "SUCCESS") {
            var stockId = seqresult["result"];

            //attrDtl["vnm"] = stockId;

            let sqlQ = "insert into stock_m(stock_idn,co_idn,pkt_idn,stock_type,status,in_dte,qty_on_hand,weight_on_hand,attr,version,stt,start_dt,created_ts,created_by,benchmark_rte,asking_rte) \n " +
                "values($1,$2,$3,$4,$5,current_date,$6,$7,'" + JSON.stringify(attrDtl) + "',1,1,current_date,current_timestamp,$8,$9,$10) returning pkt_code";

            params.push(stockId);
            params.push(coIdn);
            params.push(stockId);
            //params.push(stockId);
            params.push(stockTyp);
            params.push(stockStatus);
            params.push(qty);
            params.push(crtwt);
            params.push(logUsr);
            params.push(benchmarkRte);
            params.push(askingRte);
            //console.log(sqlQ);
            //console.log(params);
            coreDB.executeTransSql(tpoolconn, sqlQ, params, fmt,async function (error, result) {
                if (error) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail To Execute Query! " + error.message;;
                    console.log(outJson)
                    callback(null, outJson);
                } else {
                    //coreDB.doTransCommit(tpoolconn);
                    var rowCount = result.rowCount;
                    if (rowCount > 0) {
                        let pkt_code = result.rows[0].pkt_code || '';
                        let stockIdnList = [];
                        stockIdnList.push(stockId);
                        methodParams = {};
                        methodParams["stockIdnList"] = stockIdnList;
                        methodParams["logUsr"] = logUsr;
                        methodParams["coIdn"] = coIdn;
                        let stockMUpdateResult = await coreUtil.execUpdatePacketSort(methodParams, tpoolconn);
                        if (stockMUpdateResult["status"] == 'SUCCESS') {
                            if(rootPacket != ''){
                                qty = parseInt(qty);
                                crtwt = parseFloat(crtwt);
                               
                                let updateQ = "update stock_m  set "+
                                " qty_on_hand = qty_on_hand - "+qty+
                                " ,weight_on_hand = cast(weight_on_hand as numeric) - "+crtwt+
                                " ,attr = attr || concat('{\"qty\":', qty_on_hand - "+qty+",',\"crtwt\":',cast(attr->> 'crtwt' as numeric) - "+crtwt+",'}')::jsonb "+
                                ", modified_ts = current_timestamp, modified_by = $1 " +
                                " where  "+
                                " stt = 1 and stock_idn = $2 and co_idn=$3 "; 

                                params = [];
                                params.push(logUsr);
                                params.push(rootPacket);
                                params.push(coIdn);
                                //console.log(updateQ);
                                //console.log(params);
                                coreDB.executeTransSql(tpoolconn, updateQ, params, {}, function (error, result) {
                                    if (error) {
                                        coreDB.doTransRollBack(tpoolconn);
                                        console.log(error);
                                        outJson["status"] = "FAIL";
                                        outJson["message"] = "Error In update stock_m Method!" + error.message;
                                        console.log(outJson);
                                        callback(null, outJson);
                                    } else {
                                        //coreDB.doTransCommit(tpoolconn);
                                        outJson["status"] = "SUCCESS";
                                        outJson["message"] = "Packet Created Sucessfully";
                                        outJson["stockIdn"] = stockId;
                                        outJson["pkt_code"] = pkt_code;
                                        callback(null, outJson);
                                    }
                                })
                            } else {
                                outJson["status"] = "SUCCESS";
                                outJson["message"] = "Packet Created Sucessfully";
                                outJson["stockIdn"] = stockId;
                                callback(null, outJson);
                            }
                        } else {
                            callback(null.stockMUpdateResult);
                        }
                    } else {
                        outJson["status"] = "FAIL";
                        outJson["message"] = "Fail To Create Packet!";
                        callback(null, outJson);
                    } 
                }
            });
        } else {
            callback(null, seqresult);
        }
    })
}

function execGetStockMCPrice(methodParam,tpoolconn){
    return new Promise(function(resolve,reject) {
        getStockMCPrice(methodParam,tpoolconn, function (error, result) {
        if(error){  
          reject(error);
         }
        resolve(result);
     });
    });
}

function getStockMCPrice(paramJson,tpoolconn, callback) {
    var rootPacket = paramJson.rootPacket || '';
    var coIdn = paramJson.coIdn;

    let outJson = {};
    let params = [];
    let fmt = {};
    let sql = " select attr->>'cp' cp from stock_m where stock_idn = $1 and co_idn=$2 ";

    params = [];
    params.push(rootPacket);
    params.push(coIdn);

    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getStockMCPrice Method!";
            callback(null, outJson);
        } else {
            len = result.rows.length;
            let cp = '1';
            if (len > 0) {
                cp = result.rows[0].cp || '1';

                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                outJson["result"] = cp;
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Cp data not found";
                outJson["result"] = cp;
                callback(null, outJson);
            }
        }
    });
}

exports.getBenchMarkRte = function(redirectParam,connection,callback){
    let coIdn = redirectParam.coIdn;
    let shAttr = redirectParam.sh;
    let crtwtAttr = redirectParam.crtwt;
    let coAttr = redirectParam.co;
    let puAttr = redirectParam.pu;
    let outJson = {};
    let resultFinal = {};

    if(shAttr != '' && crtwtAttr != '' && coAttr != '' && puAttr != ''){
        let params = [coIdn, shAttr, crtwtAttr, coAttr,puAttr];
        let fmt = {};
        let query = "select get_benchmark_rte($1, $2, $3, $4, $5) rte \n";
        //console.log(query);
        ///console.log(params);
        coreDB.executeTransSql(connection, query, params, fmt, function (error, result) {
            if (error) {
                outJson["result"] = resultFinal;
                outJson["status"] = "FAIL";
                outJson["message"] = "Get get_attr_val_updn Execute Query!" + error.message;
                callback(null, outJson);
            } else {
                let len = result.rows.length;
                if (len > 0) {
                    let resultRow = result.rows[0];
                    let rte = resultRow.rte;
                    //console.log("rte",rte);

                    outJson["result"] = rte;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    outJson["result"] = resultFinal;
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Sorry no result found";
                    callback(null, outJson);
                }
            }
        });
    }  else if(shAttr == ''){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify shAttr Parameter";
        callback(null,outJson);
    }  else if(crtwtAttr == ''){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify crtwtAttr Parameter";
        callback(null,outJson);
    }    else if(coAttr == ''){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify coAttr Parameter";
        callback(null,outJson);
    }    else if(puAttr == ''){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify puAttr Parameter";
        callback(null,outJson);
    }   
}

exports.updatePacketSort = function(redirectParam,connection,callback){
    let coIdn = redirectParam.coIdn;
    let logUsr = redirectParam.logUsr;
    let stockIdnList = redirectParam.stockIdnList || [];
    let outJson = {};
    let resultFinal = {};

    if(stockIdnList.length > 0){
        let query = "update stock_m set  " +
        " sort = pkt_srt(stock_idn) "+
        ", modified_ts = current_timestamp, modified_by = $1 " +
        "where stock_idn in ("+stockIdnList.join(",")+") and stt = 1 and co_idn = $2 ";
        let params = []
        params.push(logUsr);
        params.push(coIdn);
        //console.log(query);
        //console.log(params);
        coreDB.executeTransSql(connection, query, params, {}, function (error, result) {
            if (error) {
                outJson["result"] = resultFinal;
                outJson["status"] = "FAIL";
                outJson["message"] = "Get updatePacketSort Execute Query!" + error.message;
                callback(null, outJson);
            } else {
                let len = result.rowCount;
                if (len > 0) {
                    outJson["result"] = resultFinal;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    outJson["result"] = resultFinal;
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Packet sort updation failed";
                    callback(null, outJson);
                }
            }
        });
    }  else if(stockIdnList.length == 0){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify stockIdnList Parameter";
        callback(null,outJson);
    } 
}

module.exports.modDataOfPrp = modDataOfPrp;
module.exports.floorFigure = floorFigure;
module.exports.getDateyyyymmddToExpected = getDateyyyymmddToExpected;
module.exports.getSelectQ = getSelectQ;
module.exports.getDependAttrList = getDependAttrList;
module.exports.splice = splice;
module.exports.getSelectQMix = getSelectQMix;